// ConfigureAllModule.cpp : Defines the entry point for the console application.
//



#include "stdafx.h"
#include <windows.h>
#include <tchar.h> 
#include <stdio.h>
#include <strsafe.h>
#include <string>
using namespace std;
#pragma comment(lib, "User32.lib")
//#include "dirent.h"

#define BUF_SIZE 32

int _tmain(int argc, _TCHAR* argv[])
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle;
	BYTE b_Cpt = 0;
	BYTE b_Type = 0;
	CHAR FileName[4][BUF_SIZE + 1];
	ULONG ul_AddressError = 0;
	ULONG ul_ModuleConfiguration = 0;
	DWORD dw_Temp = 0;
	DWORD dw_NumberOfChoice = 0;
	BYTE i = 0;
	LPCTSTR directory;
	CHAR fileNameTable[20][MAX_PATH];
	WIN32_FIND_DATA ffd;
	TCHAR szDir[MAX_PATH];
	HANDLE hFind = INVALID_HANDLE_VALUE;

	UNREFERENCED_PARAMETER(argv);
	UNREFERENCED_PARAMETER(argc);

	printf("Configure all modules test sample");
	printf("\n /!\\ DO NOT INTERRUPT THE PROGRAM WHILE LOADING /!\\");


	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);
	
	if(i_ReturnValue != 0)
		exit(-1);
	
	printf("\nActual configuration:");
	for (i = 0; i < 4; i++)
	{
		i_ReturnValue = i_PCI1710_GetModuleConfiguration(h_BoardHandle, i, &ul_ModuleConfiguration);
		if (i_ReturnValue != 0)
		{
			printf("\nfailed to get configuration, error %d", i_ReturnValue);
			goto sample_end;
		}

		printf("\n\tModule %d configuration %c%c%c%c ",
			i,
			(char) (ul_ModuleConfiguration >> 24) & 0xFF,
			(char) (ul_ModuleConfiguration >> 16) & 0xFF,
			(char) (ul_ModuleConfiguration >> 8) & 0xFF,
			(char) ul_ModuleConfiguration & 0xFF);
	}

	printf("\n");

	i_ReturnValue = i_PCI1710_GetBoardHardwareType(h_BoardHandle, &b_Type);
	if(i_ReturnValue != 0)
	{
		printf("\n i_PCI1710_GetBoardHardwareType Error : %d -> You should better NOT try \
			   to change configuration, unless you are absolutely sure of what you will do !", 
			   i_ReturnValue);
		goto sample_end;
	}

	if (b_Type == 0)
	{
		directory = TEXT(".\\cfg\\*");
		printf("\n This board uses 10K10. So use the following config files.\n");
	}
	else
	{
		directory = TEXT(".\\CFG_10K20\\*");
		printf("\n This board uses 10K20. So use the following config files.\n");
	}
	

	StringCchCopy(szDir, MAX_PATH, directory);
	
	hFind = FindFirstFile(szDir, &ffd);
	FindNextFile(hFind, &ffd); // used to eliminate the "." file 
	FindNextFile(hFind, &ffd); // used to eliminate the ".." file 


	if (INVALID_HANDLE_VALUE == hFind) 
	{
	  printf ("FindFirstFile error\n");
	  return -1;
	}
	
	do
    {
		
		 _tprintf(TEXT(" %i:  %s \n"), dw_NumberOfChoice, ffd.cFileName); // display the list of files
		 {
			size_t sz = 0;
			char charFileName[MAX_PATH];
			memset(charFileName,0, sizeof(char)*MAX_PATH);
#ifdef _WIN64
			int i= 0;
			i = strlen(ffd.cFileName);
			ffd.cFileName[i] = '\0';
			strcpy(charFileName,ffd.cFileName);
#else
			wcstombs_s (&sz, charFileName, (size_t)MAX_PATH, (const wchar_t *)ffd.cFileName, (size_t)MAX_PATH); // convert wchar to char

#endif
				
			 if (b_Type == 0) 
				 sprintf_s (fileNameTable[dw_NumberOfChoice], "CFG\\%s", charFileName);
			 else
				 sprintf_s (fileNameTable[dw_NumberOfChoice], "CFG_10K20\\%s", charFileName);
		 }

		 dw_NumberOfChoice++;
    }

    while (FindNextFile(hFind, &ffd) != 0);
   
    FindClose(hFind);
 
	/*Initialization of the parameters*/
	for(b_Cpt = 0 ; b_Cpt < 4 ; b_Cpt++)
	{
		do
		{
			printf("\n File you want to load for module %d (choose the corresponding number): ", b_Cpt);
			scanf_s("%d", &dw_Temp);
		}
		while(dw_Temp > dw_NumberOfChoice);
		sprintf_s(FileName[b_Cpt], BUF_SIZE, fileNameTable[dw_Temp]);
	}

	printf("\n You choose : %s \n\t %s, \n\t %s, \n\t %s", 
		FileName[0], 
		FileName[1], 
		FileName[2], 
		FileName[3] );

	i_ReturnValue = i_PCI1710_ConfigureAllModule(h_BoardHandle,
		FileName[0],
		FileName[1],
		FileName[2],
		FileName[3],
		&ul_AddressError);

	if(i_ReturnValue == 0)
		printf("\n i_PCI1710_ConfigureAllModule Ok");
	else 
		printf("\n i_PCI1710_ConfigureAllModule Error : %d", i_ReturnValue);

	printf("\n\nNew configuration:");

	for (i = 0; i < 4; i++)
	{
		i_ReturnValue = i_PCI1710_GetModuleConfiguration(h_BoardHandle, i, &ul_ModuleConfiguration);
		if (i_ReturnValue != 0)
		{
			printf("\nfailed to get configuration, error %d", i_ReturnValue);
			goto sample_end;
		}

		printf("\n\tModule %d configuration %c%c%c%c",
			i,
			(char) (ul_ModuleConfiguration >> 24) & 0xFF,
			(char) (ul_ModuleConfiguration >> 16) & 0xFF,
			(char) (ul_ModuleConfiguration >> 8) & 0xFF,
			(char) ul_ModuleConfiguration & 0xFF);
	}

sample_end:
	i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);

	printf("\n Press any key to exit the sample ...");
	_getch();



	return 0;
}

