// ReadAllTimer.cpp : Defines the entry point for the console application.
//



#include "stdafx.h"


int _tmain(int argc, _TCHAR* argv[])
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle = NULL;
	BYTE b_Module = 0;
	BYTE b_TimerNbr = 0;
	BYTE b_TimerMode[3] = {0, 0, 0};
	BYTE b_InputClk = 0;
	BYTE b_InputClkLevel = 0;
	BYTE b_OutputLevel = 0;
	BYTE b_HardGateLevel = 0;
	BYTE b_InterruptFlag = 0;
	DWORD dw_Temp = 0;
	DWORD dw_ReloadValue[3] = {0, 0, 0};
	DWORD dw_Value[3] = {0, 0, 0};
	BYTE b_SuccessfullyInitTimer = 0;


	printf("Read timer value test sample");
	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);

	if(i_ReturnValue == 0)
	{
		/*Initialization of the parameters*/

		/*Set the module*/
		do
		{
			_flushall();
			printf("\nSelect the module (0 to 3) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 3);

		b_Module = (BYTE)dw_Temp;

		/* loop on the 3 timers to chose how to init them
		 * We do not use interrupts in this sample */
		for(b_TimerNbr = 0 ; b_TimerNbr < 3 ; b_TimerNbr++)
		{
			/*Set the mode*/
			do
			{
				_flushall();
				printf("\nMode \t Description");
				printf("\n0 \t Interrupt at the end of the counting process");
				printf("\n1 \t Monoflop, retriggerable through hardware");
				printf("\n2 \t Pulse generator");
				printf("\n3 \t Square-wave generator");
				printf("\n4 \t Strobe, Triggered through software");
				printf("\n5 \t Strobe, trigger through hardware (retriggerable)");
				printf("\nSelect the mode : ");
				scanf_s("%u", &dw_Temp);
			}
			while(dw_Temp > 5);

			b_TimerMode[b_TimerNbr] = (BYTE)dw_Temp;

			/*Set the reload value*/
			_flushall();
			printf("\nSelect the reload value (< 4 294 967 295) : ");
			scanf_s("%u", &dw_ReloadValue[b_TimerNbr]);
		}

		/*Initialize the three timers*/
		for(b_TimerNbr = 0 ; b_TimerNbr < 3 ; b_TimerNbr++)
		{
			i_ReturnValue = i_PCI1710_InitTimer(h_BoardHandle,
												b_Module,
												b_TimerNbr,
												b_TimerMode[b_TimerNbr],
												dw_ReloadValue[b_TimerNbr],
												b_InputClk,
												b_InputClkLevel,
												b_OutputLevel,
												b_HardGateLevel);

			if(i_ReturnValue == 0)
			{
				printf("\n i_PCI1710_InitTimer %u Ok", b_TimerNbr);
				b_SuccessfullyInitTimer++;
			}
			else
			{
				printf("\n i_PCI1710_InitTimer %d Error : %u", b_TimerNbr, i_ReturnValue);
				break;
			}
		}

		/*Test if initialization of all timers are Ok*/
		if(b_SuccessfullyInitTimer == 3)
		{
			printf("\n All timers have been successfully intialized");

			/*It will count the number of successfully enabled timers*/
			dw_Temp = 0;

			/*Enable and start all timers*/
			for(b_TimerNbr = 0 ; b_TimerNbr < 3 ; b_TimerNbr++)
			{
				i_ReturnValue = i_PCI1710_EnableTimer(h_BoardHandle, 
													b_Module,
													b_TimerNbr,
													b_InterruptFlag);

				if(i_ReturnValue == 0)
				{
					printf("\n i_PCI1710_EnableTimer %u Ok", b_TimerNbr);
					dw_Temp++;
				}
				else
				{
					printf("\n i_PCI1710_EnableTimer %d Error : %d", b_TimerNbr, i_ReturnValue);
					break;
				}
			}

			/*Test if timer well enabled*/
			if(dw_Temp == 3)
			{
				printf("\n All timers have been successfully enabled");

				printf("\n Press ESC to quit, t to rewrite the reload value (mode 4 or 5 only)");

				_flushall();

				for(;;)
				{
					if(_kbhit())
					{
						dw_Temp = _getch();
						/*Quit the program if ESC is pressed*/
						if(dw_Temp == 27)
							break;
						/*If t key is pressed we write values on all the timers*/
						if((dw_Temp == 't') || (dw_Temp == 'T'))
						{
							dw_Temp = 0;
							for(b_TimerNbr = 0 ; b_TimerNbr < 3 ; b_TimerNbr++)
							{
								i_ReturnValue = i_PCI1710_WriteTimerValue(h_BoardHandle,
																	b_Module,
																	b_TimerNbr,
																	dw_ReloadValue[b_TimerNbr]);

								if(i_ReturnValue == 0)
								{
									printf("\n i_PCI1710_WriteTimerValue %u Ok", b_TimerNbr);
								}
								else
								{
									printf("\n i_PCI1710_WriteTimerValue %u Error : %d", 
											b_TimerNbr, 
											i_ReturnValue);
									/*If one of the write operation failed we put a special value in dw_Temp
									 *to then stop the program*/
									dw_Temp = 0xFFFFFFFF;
									break;
								}
							}
							if(dw_Temp == 0xFFFFFFFF)
								break;
						}
					}/*if(kbhit())*/

					i_ReturnValue = i_PCI1710_ReadAllTimerValue(h_BoardHandle,
																b_Module,
																dw_Value);

					/*Test if reading of the value failed*/
					if(i_ReturnValue != 0)
					{
						printf("\n i_PCI1710_ReadTimerValue Error : %d", i_ReturnValue);
						break;
					}

					/*get output level, progress for all timers and display it*/
					printf("\n");
					for(b_TimerNbr = 0 ; b_TimerNbr < 3 ; b_TimerNbr++)
					{
						/*Display the timer status, value and output status*/
						printf("\t Timer %u -> %u",
								b_TimerNbr,
								dw_Value[b_TimerNbr]);
					}

					/*Slow the display to be more human readable*/
					Sleep(200);
				}
			}
			else
			{
				printf("\n i_PCI1710_EnableTimer Error : %d", i_ReturnValue);			
			}
			
			/*Disable previously enabled timers*/
			for(b_TimerNbr = 0 ; b_TimerNbr < b_SuccessfullyInitTimer ; b_TimerNbr++)
			{
				i_ReturnValue = i_PCI1710_DisableTimer(h_BoardHandle, b_Module, b_TimerNbr);
	
				/*Test if timer well disabled*/
				if(i_ReturnValue == 0)
				{
					printf("\n i_PCI1710_DisableTimer %d Ok", b_TimerNbr);
				}	
				else 
				{
					printf("\n i_PCI1710_DisableTimer %d Error : %d",b_TimerNbr, i_ReturnValue);
				}
			}
		}

		i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
	}
	else
	{
		printf("\n i_PCI1710_InitTimer Error : %d", i_ReturnValue);
	}

	printf("\n Press any key to exit the sample ...");
	_getch();
	


	return 0;
}

