// ReadTimer.cpp : Defines the entry point for the console application.
//



#include "stdafx.h"


BYTE b_GlobalIntOccured;
DWORD dw_GlobalIntSource;
DWORD dw_GlobalIntMask;
DWORD dw_GlobalIntCpt;

void WINAPI v_InterruptRoutine(HANDLE h_BoardHandle, 
						DWORD dw_Status, 
						DWORD dw_InterruptSource, 
						DWORD dw_InterruptMask,
						DWORD dw_ArgSize,
						PDWORD pdw_Args)
{
	/*The timer interrupts does not use pdw_Args*/

	/*In this function we just pass the arguments to the main via global variables*/
	dw_GlobalIntSource = dw_InterruptSource;
	dw_GlobalIntMask = dw_InterruptMask;
	dw_GlobalIntCpt++;

	/*Signal to the main that an interrupt occured*/
	b_GlobalIntOccured = 1;
}


int _tmain(int argc, _TCHAR* argv[])
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle = NULL;
	BYTE b_Module = 0;
	BYTE b_TimerNbr = 0;
	BYTE b_TimerMode = 0;
	BYTE b_InputClk = 0;
	BYTE b_InputClkLevel = 0;
	BYTE b_OutputLevel = 0;
	BYTE b_HardGateLevel = 0;
	BYTE b_InterruptFlag = 0;
	BYTE b_Status = 0;
	DWORD dw_Temp = 0;
	DWORD dw_ReloadValue = 0;
	DWORD dw_Value = 0;

	/*No interrupt occured yet*/
	b_GlobalIntOccured = 0;
	dw_GlobalIntCpt = 0;

	printf("Read timer value test sample");
	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);

	if(i_ReturnValue ==0)
	{
		/*Initialization of the parameters*/

		/*Set the module*/
		do
		{
			_flushall();
			printf("\nSelect the module (0 to 3) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 3);

		b_Module = (BYTE)dw_Temp;

		/*Set the timer nbr*/
		do
		{
			_flushall();
			printf("\nSelect the timer (0 to 2) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 2);

		b_TimerNbr = (BYTE)dw_Temp;

		/*Set the mode*/
		do
		{
			_flushall();
			printf("\nMode \t Description");
			printf("\n0 \t Interrupt at the end of the counting process");
			printf("\n1 \t Monoflop, retriggerable through hardware");
			printf("\n2 \t Pulse generator");
			printf("\n3 \t Square-wave generator");
			printf("\n4 \t Strobe, Triggered through software");
			printf("\n5 \t Strobe, trigger through hardware (retriggerable)");
			printf("\nSelect the mode : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 5);

		b_TimerMode = (BYTE)dw_Temp;

		/*Set the reload value*/
		_flushall();
		printf("\nSelect the reload value (< 4 294 967 295) : ");
		scanf_s("%u", &dw_ReloadValue);

		/*Set clock selection*/
		do
		{
			_flushall();
			printf("\nSelect the input clock (0->PCI bus clock, 1->ext clock, 2->10MHz internal clock) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 2);

		b_InputClk = (BYTE)dw_Temp;

		/*Set clock level*/
		do
		{
			_flushall();
			printf("\nSelect the input clock level (0->active low, 1->active high) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 1);

		b_InputClkLevel = (BYTE)dw_Temp;

		/*Set output level*/
		do
		{
			_flushall();
			printf("\nSelect the output level (0->active low, 1->active high) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 1);

		b_OutputLevel = (BYTE)dw_Temp;

		/*Set hardware gate*/
		do
		{
			_flushall();
			printf("\nSelect the hardware gate (0->active low, 1->active high) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 5);

		b_HardGateLevel = (BYTE)dw_Temp;

		/*Set interrupt flag*/
		do
		{
			_flushall();
			printf("\nEnable interrupt : (0->disabled, 1->enabled) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 1);

		b_InterruptFlag = (BYTE)dw_Temp;
		
		i_ReturnValue = i_PCI1710_InitTimer(h_BoardHandle,
										b_Module,
										b_TimerNbr,
										b_TimerMode,
										dw_ReloadValue,
										b_InputClk,
										b_InputClkLevel,
										b_OutputLevel,
										b_HardGateLevel);

		/*Test if initialization is Ok*/
		if(i_ReturnValue == 0)
		{
			printf("\n i_PCI1710_InitTimer Ok");

			if(b_InterruptFlag != 0)
			{
				/*Associate our interrupt routine with the board if interrupt are used*/
				i_ReturnValue = i_PCI1710_SetBoardIntRoutine(h_BoardHandle, 
															v_InterruptRoutine);

				if(i_ReturnValue == 0)
				{
					printf("\n i_PCI1710_SetBoardIntRoutine Ok");
				}
				else
				{
					printf("\n i_PCI1710_SetBoardIntRoutine Error : %d", i_ReturnValue);
				}
			}

			/*Start the timer*/
			i_ReturnValue = i_PCI1710_EnableTimer(h_BoardHandle, 
												b_Module,
												b_TimerNbr,
												b_InterruptFlag);

			/*Test if timer well enabled*/
			if(i_ReturnValue == 0)
			{
				printf("\n i_PCI1710_EnableTimer Ok");

				printf("\n Press ESC to quit, t key to rewrite the reload value");

				for(;;)
				{
					if(_kbhit())
					{
						dw_Temp = _getch();
						/*Stop the sample if ESC is pressed*/
						if(dw_Temp == 27)
							break;
						/*Rewrite the reload value is t is pressed*/
						if(dw_Temp == 't' || dw_Temp == 'T')
						{
							i_ReturnValue = i_PCI1710_WriteTimerValue(h_BoardHandle,
																	b_Module, 
																	b_TimerNbr,
																	dw_ReloadValue);
							if(i_ReturnValue == 0)
							{
								printf("\n i_PCI1710_WriteTimerValue Ok \n");
							}
							else
							{
								printf("\n i_PCI1710_WriteTimerValue Error : %d \n", i_ReturnValue);
								break;
							}
						}
					}

					i_ReturnValue = i_PCI1710_ReadTimerValue(h_BoardHandle,
														b_Module,
														b_TimerNbr,
														&dw_Value);

					/*Test if reading of the value failed*/
					if(i_ReturnValue != 0)
					{
						printf("\n i_PCI1710_ReadTimerValue Error : %d", i_ReturnValue);
						break;
					}

					i_ReturnValue = i_PCI1710_GetTimerOutputLevel(h_BoardHandle,
															b_Module,
															b_TimerNbr,
															&b_OutputLevel);
				
					/*Test if reading of the output failed*/
					if(i_ReturnValue != 0)
					{
						printf("\n i_PCI1710_GetTimerOutputLevel Error : %d", i_ReturnValue);
						break;
					}

					i_ReturnValue = i_PCI1710_GetTimerProgressStatusEx(h_BoardHandle,
																b_Module,
																b_TimerNbr,
																&b_Status);

					/*Test if reading of the progress failed*/
					if(i_ReturnValue != 0)
					{
						printf("\n i_PCI1710_GetTimerProgressStatusEx Error : %d", i_ReturnValue);
						break;
					}

					/*Display the timer status, value and output status*/
					printf("\n Timer %d, progress : %u, value : %u, output : %u",
						b_TimerNbr,
						b_Status,
						dw_Value,
						b_OutputLevel);
					
					/*If interrupt are used test if one occured*/
					if(b_GlobalIntOccured != 0)
					{
						printf("\n An interrupt occured !");

						/* Since the mask is (1 << ModuleNbr) 
						 * to have the right module number we need to modify it */
						switch(dw_GlobalIntSource)
						{
							case 0x1:
								dw_GlobalIntSource = 0;
								break;
							case 0x2:
								dw_GlobalIntSource = 1;
								break;
							case 0x4:
								dw_GlobalIntSource = 2;
								break;
							case 0x8:
								dw_GlobalIntSource = 3;
								break;
							default:
								printf("\n We have a problem with the source.");
								break;
						}

						/* Since the mask is (1 << (TimerNbr + 4)) 
						 * to have the right timer number we need to modify it */
						if(dw_GlobalIntMask & 0x10UL)
						{
							printf("\n Interrupt % d -> The source is the timer 0 on the module %d", 
									dw_GlobalIntCpt,
									dw_GlobalIntSource);
						}
						if(dw_GlobalIntMask & 0x20UL)
						{
							printf("\n Interrupt % d -> The source is the timer 1 on the module %d", 
									dw_GlobalIntCpt,
									dw_GlobalIntSource);
						}
						if(dw_GlobalIntMask & 0x40UL)
						{
							printf("\n Interrupt % d -> The source is the timer 2 on the module %d", 
									dw_GlobalIntCpt,
									dw_GlobalIntSource);
						}

						/*Wait for the user to see the interrupt*/
						//printf("\n Press a key to continue");
						//_getch();
						
						b_GlobalIntOccured = 0;
					}
				}

				i_ReturnValue = i_PCI1710_DisableTimer(h_BoardHandle, b_Module, b_TimerNbr);
	
				/*Test if timer well disabled*/
				if(i_ReturnValue == 0)
				{
					printf("\n i_PCI1710_DisableTimer Ok");
				}	
				else 
				{
					printf("\n i_PCI1710_DisableTimer Error : %d", i_ReturnValue);
				}

				/*Reset interrupt if it has been set*/
				if(b_InterruptFlag != 0)
				{
					i_ReturnValue = i_PCI1710_ResetBoardIntRoutine(h_BoardHandle);

					if(i_ReturnValue == 0)
					{
						printf("\n i_PCI1710_ResetBoardIntRoutine Ok");
					}
					else
					{
						printf("\n i_PCI1710_ResetBoardIntRoutine Error : %d", i_ReturnValue);
					}
				}
			}
			else
			{
				printf("\n i_PCI1710_EnableTimer Error : %d", i_ReturnValue);			
			}
		}

		i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
	}
	else
	{
		printf("\n i_PCI1710_InitTimer Error : %d", i_ReturnValue);
	}

	printf("\n Press any key to exit the sample ...");
	_getch();
	


	return 0;
}

