#include "stdafx.h"

char * pcFormatOut (BYTE b_DigitalInputsValue)
{
	static char cOut[100];
	
	sprintf (cOut, "C:%d D:%d E:%d F:%d G:%d A:%d B:%d", b_DigitalInputsValue & 1, (b_DigitalInputsValue >> 1) & 1, (b_DigitalInputsValue >> 2) & 1,
	(b_DigitalInputsValue >> 3) & 1, (b_DigitalInputsValue >> 4) & 1, (b_DigitalInputsValue >> 5) & 1, (b_DigitalInputsValue >> 6) & 1);
	
	return (cOut);
}


int _tmain(int /*argc*/, _TCHAR* /*argv[]*/ )
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle;

	BYTE	b_Module, b_PortAMode, b_PortBMode, b_DigitalInputsValue;
	DWORD	dw_Temp = 0;

	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);
	if ( i_ReturnValue != 0)
	{
		printf("\n Error %d in i_Utils_OpenBoard", i_ReturnValue );
		goto end;
	}
	else printf("\n i_Utils_OpenBoard OK" );


	// Set the module in which to read
	do
	{
		_flushall();
		printf("\n Select the module (0 to 3) : ");
		scanf_s("%d", &dw_Temp);
	}
	while(dw_Temp > 3);
	b_Module = (BYTE) dw_Temp;

	
	// Set input A as input/output
	do
	{
		_flushall();
		printf("\n Set signal A (0: Input, 1: Output) : ");
		scanf_s("%d", &dw_Temp);
	}
	while(dw_Temp > 1);
	switch( dw_Temp )
	{
		case 0: b_PortAMode = PCI1710_PORT_INPUT;	break;
		case 1: b_PortAMode = PCI1710_PORT_OUTPUT;	break;
		default: printf("\n Invalid port A mode");	goto cleanup;
	}
	

	// Set input B as input/output
	do
	{
		_flushall();
		printf("\n Set signal B (0: Input, 1: Output) : ");
		scanf_s("%d", &dw_Temp);
	}
	while(dw_Temp > 1);
	switch( dw_Temp )
	{
		case 0: b_PortBMode = PCI1710_PORT_INPUT;	break;
		case 1: b_PortBMode = PCI1710_PORT_OUTPUT;	break;
		default: printf("\n Invalid port A mode");	goto cleanup;
	}

	

	i_ReturnValue = i_PCI1710_SetPortConfiguration( h_BoardHandle, b_Module, b_PortAMode, b_PortBMode );
	if ( i_ReturnValue != 0)
	{
		printf("\n Error %d in i_PCI1710_SetPortConfiguration", i_ReturnValue );
		goto cleanup;
	}
	else printf("\n i_PCI1710_SetPortConfiguration OK");

	printf("\n");

	do
	{
		i_ReturnValue = i_PCI1710_ReadDigitalInputs( h_BoardHandle, b_Module, &b_DigitalInputsValue );
		if ( i_ReturnValue != 0)
		{
			printf("\n Error %d in i_PCI1710_ReadDigitalInputs", i_ReturnValue );
			goto cleanup;
		}

		printf(" Digital inputs are 0x%02X. %s \r", b_DigitalInputsValue, pcFormatOut(b_DigitalInputsValue) );

		Sleep(100);
	}
	while( !_kbhit() );
	_getch();

	printf("\n");


cleanup:
	i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
	if ( i_ReturnValue != 0) printf("\n Error %d in i_PCI1710_CloseBoard", i_ReturnValue );
	else printf("\n i_PCI1710_CloseBoard OK" );


end:
	printf("\n Press any key to exit the sample ...");
	_getch();

	return 0;
}

