#include "stdafx.h"


char * pcFormatOut (BYTE b_OutputValue)
{
	static char cOut[50];
	
	sprintf (cOut, "H: %d A: %d B: %d", b_OutputValue & 1, (b_OutputValue >> 1) & 1, (b_OutputValue >> 2) & 1);
	
	return (cOut);
}

int _tmain(int /*argc*/, _TCHAR* /*argv[]*/ )
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle;

	BYTE	b_OutputValue = 1, b_OnOff = 1;
	DWORD	dw_Temp = 0;
	BYTE	b_Module, b_UseDOM, b_PortAMode, b_PortBMode;


	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);
	if ( i_ReturnValue != 0)
	{
		printf("\n Error %d in i_Utils_OpenBoard", i_ReturnValue );
		goto end;
	}
	else printf("\n i_Utils_OpenBoard OK" );


	// Set the module in which to write
	do
	{
		_flushall();
		printf("\n Select the module (0 to 3) : ");
		scanf_s("%d", &dw_Temp);
	}
	while(dw_Temp > 3);
	b_Module = (BYTE) dw_Temp;

	
	// Set input A as input/output
	do
	{
		_flushall();
		printf("\n Set signal A (0: Input, 1: Output) : ");
		scanf_s("%d", &dw_Temp);
	}
	while(dw_Temp > 1);
	switch( dw_Temp )
	{
		case 0: b_PortAMode = PCI1710_PORT_INPUT;	break;
		case 1: b_PortAMode = PCI1710_PORT_OUTPUT;	break;
		default: printf("\n Invalid port A mode");	goto cleanup;
	}
	

	// Set input B as input/output
	do
	{
		_flushall();
		printf("\n Set signal B (0: Input, 1: Output) : ");
		scanf_s("%d", &dw_Temp);
	}
	while(dw_Temp > 1);
	switch( dw_Temp )
	{
		case 0: b_PortBMode = PCI1710_PORT_INPUT;	break;
		case 1: b_PortBMode = PCI1710_PORT_OUTPUT;	break;
		default: printf("\n Invalid port B mode");	goto cleanup;
	}


	// Set output memory
	do
	{
		_flushall();
		printf("\n Use digital output memory? (0: No, 1: Yes) : ");
		scanf_s("%d", &dw_Temp);
	}
	while(dw_Temp > 1);
	switch( dw_Temp )
	{
		case 0: b_UseDOM = PCI1710_DISABLE;	break;
		case 1: b_UseDOM = PCI1710_ENABLE;	break;
		default: printf("\n Invalid digital output memory mode");	goto cleanup;
	}

	

	i_ReturnValue = i_PCI1710_SetPortConfiguration( h_BoardHandle, b_Module, b_PortAMode, b_PortBMode );
	if ( i_ReturnValue != 0)
	{
		printf("\n Error %d in i_PCI1710_SetPortConfiguration", i_ReturnValue );
		goto cleanup;
	}
	else printf("\n i_PCI1710_SetPortConfiguration OK");


	i_ReturnValue = i_PCI1710_SetDigitalOutputMemory ( h_BoardHandle, b_UseDOM );
	if ( i_ReturnValue != 0)
	{
		printf("\n Error %d in i_PCI1710_SetDigitalOutputMemory", i_ReturnValue );
		goto cleanup;
	}
	printf("\n i_PCI1710_SetDigitalOutputMemory OK");

	
	for(;;)
	{
		if ( b_OnOff )
		{
			i_ReturnValue = i_PCI1710_SetDigitalOutputsOn( h_BoardHandle, b_Module, b_OutputValue );
			if ( i_ReturnValue != 0)
			{
				printf("\n Error %d in i_PCI1710_SetDigitalOutputs", i_ReturnValue );
				goto cleanup;
			}
			printf("\n Digital output 0x%x set. %s", b_OutputValue, pcFormatOut(b_OutputValue) );
		}
		else
		{
			i_ReturnValue = i_PCI1710_SetDigitalOutputsOff( h_BoardHandle, b_Module, b_OutputValue );
			if ( i_ReturnValue != 0)
			{
				printf("\n Error %d in i_PCI1710_SetDigitalOutputsOff", i_ReturnValue );
				goto cleanup;
			}
			printf("\n Digital output 0x%x reset. %s", b_OutputValue, pcFormatOut(b_OutputValue) );
		}

		printf("\n Press any other key to set the next output value or escape  to stop the sample ");
		
		switch( _getch() )
		{
			case 27: goto cleanup; // Esc. character
			default: break;
		}

		b_OutputValue = b_OutputValue << 1;

		if ( b_OutputValue > 0x7 )
		{
			b_OutputValue = 1;
			if ( b_UseDOM ) b_OnOff = !b_OnOff;
		}
	}




cleanup:
	i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
	if ( i_ReturnValue != 0) printf("\n Error %d in i_PCI1710_CloseBoard", i_ReturnValue );
	else printf("\n i_PCI1710_CloseBoard OK" );


end:
	printf("\n Press any key to exit the sample ...");
	_getch();

	return 0;
}

