// ReadETMDutyCycleValue.cpp : Defines the entry point for the console application.
//


#include "stdafx.h"


int _tmain(int argc, _TCHAR* argv[])
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle = NULL;
	DWORD dw_Temp = 0;
	BYTE b_Module = 0;
	BYTE b_ETMNbr = 0;
	BYTE b_InputClk = 0;
	BYTE b_TimingUnit = 0;
	DWORD dw_Timing = 0;
	DWORD dw_RealTiming = 0;
	BYTE b_EdgeLevel = 0;
	BYTE b_TriggerLevel = 0;
	BYTE b_CycleMode = 0;
	BYTE b_FirstTriggerMode = 0;

	UNREFERENCED_PARAMETER(argc);
	UNREFERENCED_PARAMETER(argv);

	printf("Read ETM value test sample");
	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);
	if (i_ReturnValue != 0)
		return -1;

	/* Set the module */
	do
	{
		_flushall();
		printf("\nSelect the module (0 to 3): ");
		scanf_s("%u", &dw_Temp);
	}
	while (dw_Temp > 3);
	b_Module = (BYTE)dw_Temp;
	
	/* Set the counter number */
	do
	{
		_flushall();
		printf("Select the number of the ETM counter (0 to 1): ");
		scanf_s("%u", &dw_Temp);
	}
	while (dw_Temp > 1);
	b_ETMNbr = (BYTE)dw_Temp;

	/* Set the input clock */
	do
	{
		_flushall();
		printf("Select the input clock (PCI 30MHz, PCI 33MHz or onboard 40 MHz): ");
		scanf_s("%u", &dw_Temp);
	}
	while (dw_Temp != 30 && dw_Temp != 33 && dw_Temp != 40);
	b_InputClk = (BYTE)dw_Temp;

	/* Set the timing unit */
	do
	{
		_flushall();
		printf("Select the timing unit (0: ns, 1: us, 2: ms): ");
		scanf_s("%u", &dw_Temp);
	}
	while (dw_Temp > 2);
	b_TimingUnit = (BYTE)dw_Temp;

	/* Set the timing value */
	do
	{
		_flushall();
		printf("Select the timing value: ");
		scanf_s("%u", &dw_Temp);
	}
	while (dw_Temp == 0 || dw_Temp > 559240500);
	dw_Timing = dw_Temp;

	/* Initialize the ETM counter */
	i_ReturnValue = i_PCI1710_InitETM(h_BoardHandle,
									  b_Module,
									  b_InputClk,
									  b_TimingUnit,
									  dw_Timing,
									  &dw_RealTiming);
	if (i_ReturnValue != 0)
	{
		printf("\n i_PCI1710_InitETM Error : %d", i_ReturnValue);
		_getch();
		return -1;
	}
	else
		printf("\ni_PCI1710_InitETM OK; real timing setting is %d.\n\n", dw_RealTiming);

	/* Set the measured level */
	do
	{
		_flushall();
		printf("Measure low (0) or high (1) level: ");
		scanf_s("%u", &dw_Temp);
	}
	while (dw_Temp > 1);
	b_EdgeLevel = (BYTE)dw_Temp;

	/* Set the trigger level */
	do
	{
		_flushall();
		printf("Trigger on falling edge (0) or rising edge (1): ");
		scanf_s("%u", &dw_Temp);
	}
	while (dw_Temp > 1);
	b_TriggerLevel = (BYTE)dw_Temp;

	/* Set the cycle mode */
	do
	{
		_flushall();
		printf("Run once (0) or continuously (1): ");
		scanf_s("%u", &dw_Temp);
	}
	while (dw_Temp > 1);
	b_CycleMode = (BYTE)dw_Temp;

	/* Set the first trigger mode */
	do
	{
		_flushall();
		printf("Start measuring immediately (0) or after the first trigger (1): ");
		scanf_s("%u", &dw_Temp);
	}
	while (dw_Temp > 1);
	b_FirstTriggerMode = (BYTE)dw_Temp;

	/* Enable the ETM counter */
	i_ReturnValue = i_PCI1710_EnableETM(h_BoardHandle,
										b_Module,
										b_ETMNbr,
										b_EdgeLevel,
										b_TriggerLevel,
										b_CycleMode,
										b_FirstTriggerMode,
										0  /* Disable interrupts */
										);
	if (i_ReturnValue != 0)
	{
		printf("\n i_PCI1710_EnableETM Error : %d", i_ReturnValue);
		_getch();
		return -1;
	}
	else
		printf("\ni_PCI1710_EnableETM OK.\n");

	printf("\n Press ESC to exit\n\n");

	for (;;)
	{
		BYTE b_ETMStatus;
		DOUBLE d_ETMDutyCycleValue;
		
		/* Read the ETM counter value */
		i_ReturnValue = i_PCI1710_ReadETMDutyCycleValue(h_BoardHandle,
		                                                b_Module,
		                                                b_ETMNbr,
		                                                0, /* No timeout */
		                                                &b_ETMStatus,
		                                                &d_ETMDutyCycleValue);
		if (i_ReturnValue != 0)
		{
			printf("\n i_PCI1710_ReadETMDutyCycleValue Error : %d", i_ReturnValue);
			_getch();
			return -1;
		}

		printf("ETM duty cycle value: %5.3f%%\r", d_ETMDutyCycleValue);

		if (b_CycleMode == 0 || (_kbhit() && _getch() == VK_ESCAPE))
			break;

		Sleep(10);
	}

	/* Disable the ETM counter */
	i_ReturnValue = i_PCI1710_DisableETM(h_BoardHandle, b_Module, b_ETMNbr);
	if (i_ReturnValue != 0)
		printf("\n i_PCI1710_DisableETM Error : %d", i_ReturnValue);

	i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
	printf("\n Press any key to exit the sample ...");
	_getch();

	return 0;
}
