// Filter.cpp : Defines the entry point for the console application.

#include "stdafx.h"

int _tmain(int argc, _TCHAR* argv[])
{
	int    i_ReturnValue = 0;
	HANDLE h_BoardHandle = NULL;
	BYTE   b_ModuleNbr = 0;
	BYTE   b_PCIInputClock = 0;
	BYTE   b_Filter = 0;
	DWORD  dw_Temp = 0;

	UNREFERENCED_PARAMETER(argc);
	UNREFERENCED_PARAMETER(argv);

	printf("Set filter for incremental counter or impulse counter sample\n");
	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);
	if(i_ReturnValue != 0)
		exit(-1);

	/* Select the module */
	do
	{
		_flushall();
		printf("\nSelect the module (0 to 3) : ");
		scanf_s("%u", &dw_Temp);
	}
	while(dw_Temp > 3);
	b_ModuleNbr = (BYTE)dw_Temp;

	/* Select the input clock */
	do
	{
		_flushall();
		printf("\nSelect the input clock (33MHz or 40MHz) : ");
		scanf_s("%u", &dw_Temp);
	}
	while(dw_Temp != 33 && dw_Temp != 40);
	b_PCIInputClock = (BYTE)dw_Temp;

	/* Select the filter clock */
	if(b_PCIInputClock == 33)
	{
		do
		{
			_flushall();
			printf("\nSelect the filter selection: "
				"\n\t0: filter not used"
				"\n\t1: 121 ns"
				"\n\t2: 182 ns"
				"\n\t3: 242 ns"
				"\n\t4: 303 ns"
				"\n\t5: 364 ns"
				"\n\t6: 424 ns"
				"\n\t7: 485 ns"
				"\n\t8: 545 ns"
				"\n\t9: 606 ns"
				"\n\t10: 667 ns"
				"\n\t11: 727 ns"
				"\n\t12: 788 ns"
				"\n\t13: 848 ns"
				"\n\t14: 909 ns"
				"\n\t15: 970 ns\n\n");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 15);
	}
	else
	{
		do
		{
			_flushall();
			printf("\nSelect the filter selection: "
				"\n\t0: filter not used"
				"\n\t1: 100 ns"
				"\n\t2: 150 ns"
				"\n\t3: 200 ns"
				"\n\t4: 250 ns"
				"\n\t5: 300 ns"
				"\n\t6: 350 ns"
				"\n\t7: 400 ns"
				"\n\t8: 450 ns"
				"\n\t9: 500 ns"
				"\n\t10: 550 ns"
				"\n\t11: 600 ns"
				"\n\t12: 650 ns"
				"\n\t13: 700 ns"
				"\n\t14: 750 ns"
				"\n\t15: 800 ns\n\n");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 15);
	}
	b_Filter = (BYTE) dw_Temp;

	/* Initialize the filter */
	i_ReturnValue = i_PCI1710_SetInputFilter(h_BoardHandle,
											 b_ModuleNbr,		 
											 b_PCIInputClock,
											 b_Filter);
	if (i_ReturnValue != 0)
		printf ("\ni_PCI1710_SetInputFilter error %d", i_ReturnValue);

	i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
	if (i_ReturnValue != 0)
		printf("\ni_PCI1710_CloseBoard Error : %d", i_ReturnValue);

	printf("\n Press any key to exit the sample ...");
	_getch();

	return 0;
}

