// CounterCompareLogicInterrupt.cpp: Defines the entry point for the console application.


#include "stdafx.h"

DWORD dw_InterruptCpt = 0;
DWORD dw_InterruptMask = 0;

VOID WINAPI v_InterruptRoutine(HANDLE   h_DeviceHandle,
                               DWORD   dw_Status,
                               DWORD   dw_InterruptSource,
                               DWORD   dw_InterruptMask,
                               DWORD   dw_ArgsSize,
                               PDWORD pdw_Args)
{
	UNREFERENCED_PARAMETER(h_DeviceHandle);
	UNREFERENCED_PARAMETER(dw_Status);
	UNREFERENCED_PARAMETER(dw_InterruptSource);
	UNREFERENCED_PARAMETER(dw_InterruptMask);
	UNREFERENCED_PARAMETER(pdw_Args);
	UNREFERENCED_PARAMETER(dw_ArgsSize);

	dw_InterruptCpt++;
}



int _tmain(int argc, _TCHAR* argv[])
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle;
	DWORD dw_Temp = 0;
	BYTE b_ModuleNbr = 0;
	BYTE b_CounterRange = 0;
	BYTE b_FirstCounterModus = 0;
	BYTE b_FirstCounterOption = 0;
	BYTE b_SecondCounterModus = 0;
	BYTE b_SecondCounterOption = 0;
	BYTE b_Cpt = 0;
	DWORD dw_CompareLogicValue = 0;
	DWORD dw_ValueRead = 0;
	DWORD dw_FirstCounterReadValue = 0;
	DWORD dw_SecondCounterReadValue = 0;
	BYTE pb_CounterModeSelection [4] = {128,15,3,0};
	CHAR *pc_CounterModeSelection [4] = {"Direct mode","Simple mode","Double mode","Quadruple mode"};
	DWORD dw_OldInterruptCpt = 0;
	UNREFERENCED_PARAMETER(argc);
	UNREFERENCED_PARAMETER(argv);
	

	printf("Test counter read write clear sample\n");

	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);
	if (i_ReturnValue != 0)
		goto end;
	puts("\n");

	/* Get module number to test */
	do
	{
		printf("Select the module you want to use (0 to 3): ");
		scanf_s("%lu", &dw_Temp);
	} while (dw_Temp > 3);
	b_ModuleNbr = (BYTE) dw_Temp;

	/* Get module range */
	do
	{
		printf("Select the module range you want to use (0: 1x32 bits, 1: 2x16bits): ");
		scanf_s("%lu", &dw_Temp);
	} while (dw_Temp > 1);
	b_CounterRange = (BYTE) dw_Temp << 4;

	if (b_CounterRange == 16) // 16 means PCI1710_16BIT_COUNTER
	{
		printf("Select the counter mode for the first counter: \n");
		do
		{
			/* Get the counter mode */
			for (b_Cpt = 0; b_Cpt < 4; b_Cpt++)
				printf("%hu. %s\n", b_Cpt, pc_CounterModeSelection[b_Cpt]);
			printf("Your selection: ");
			scanf_s ("%lu", &dw_Temp);
		} while (dw_Temp > 3);
		b_FirstCounterModus = pb_CounterModeSelection[dw_Temp];

		printf("Select the first counter option: \n");

		if (b_FirstCounterModus == 128) // 128 means PCI1710_DIRECT_MODE
		{
			do
			{
				printf("Decrement or increment (0: decrement, 1: increment): ");
				scanf_s("%lu", &dw_Temp);
			} while (dw_Temp > 1);
			b_FirstCounterOption = (BYTE) (96 * dw_Temp); // 96 means PCI1710_INCREMENT
		}
		else
		{
			do
			{
				printf("Hysteresis off or on (0: off, 1: on): ");
				scanf_s("%lu", &dw_Temp);
			} while (dw_Temp > 1);
			b_FirstCounterOption = (BYTE) (96 * dw_Temp); // 96 means PCI1710_HYSTERESIS_ON
		}

		printf("Select the counter mode: \n");
		do
		{
			/* Get the counter mode */
			for (b_Cpt = 0; b_Cpt < 4; b_Cpt++)
			{
				printf("%hu. %s\n", b_Cpt, pc_CounterModeSelection[b_Cpt]);
			}
			printf("Your selection: ");
			scanf_s ("%lu", &dw_Temp);
		} while(dw_Temp > 3);
		b_SecondCounterModus = pb_CounterModeSelection[dw_Temp];

		printf("Select the second counter option: \n");

		if (b_SecondCounterModus == 128) // 128 means PCI1710_DIRECT_MODE
		{
			do
			{
				printf("Decrement or increment (0: decrement, 1: increment): ");
				scanf_s("%lu", &dw_Temp);
			} while (dw_Temp > 1);
			b_SecondCounterOption = (BYTE) (96 * dw_Temp); // 96 means PCI1710_INCREMENT
		}
		else
		{
			do
			{
				printf("Hysteresis off or on (0: off, 1: on): ");
				scanf_s("%lu", &dw_Temp);
			} while (dw_Temp > 1);
			b_SecondCounterOption = (BYTE) (96 * dw_Temp); // 96 means PCI1710_HYSTERESIS_ON
		}
	}
	else
	{
		printf("Select the counter mode: \n");
		do
		{
			/* Get the counter mode */
			for (b_Cpt = 0; b_Cpt < 4; b_Cpt++)
				printf("%hu. %s\n", b_Cpt, pc_CounterModeSelection[b_Cpt]);
			printf("Your selection: ");
			scanf_s("%lu", &dw_Temp);
		} while (dw_Temp > 3);
		b_FirstCounterModus = pb_CounterModeSelection[dw_Temp];

		printf("Select the counter option: \n");

		if (b_FirstCounterModus == 128) // 128 means PCI1710_DIRECT_MODE
		{
			do
			{
				printf("Decrement or increment (0: decrement, 1: increment): ");
				scanf_s("%lu", &dw_Temp);
			} while (dw_Temp > 1);
			b_FirstCounterOption = (BYTE) (96 * dw_Temp); // 96 means PCI1710_INCREMENT
		}
		else
		{
			do
			{
				printf("Hysteresis off or on (0: off, 1: on): ");
				scanf_s("%lu", &dw_Temp);
			} while (dw_Temp > 1);
			b_FirstCounterOption = (BYTE) (96 * dw_Temp); // 96 means PCI1710_HYSTERESIS_ON
		}
	}

	/* Register the interrupt routine */
	i_ReturnValue = i_PCI1710_SetBoardIntRoutine(h_BoardHandle, &v_InterruptRoutine);
	if (i_ReturnValue != 0)
	{
		printf("\ni_PCI1710_SetBoardIntRoutine error: %d\n", i_ReturnValue);
		goto close;
	}
	printf("\ni_PCI1710_SetBoardIntRoutine OK\n");

	/* Initialize the incremental encoder */
	i_ReturnValue = i_PCI1710_InitCounter(h_BoardHandle,
                                           b_ModuleNbr,
                                           b_CounterRange,
                                           b_FirstCounterModus,
                                           b_FirstCounterOption,
                                           b_SecondCounterModus,
                                           b_SecondCounterOption);
	if (i_ReturnValue != 0)
	{
		printf("\ni_PCI1710_InitCounter error: %d\n", i_ReturnValue);
		goto cleanup;
	}
	printf("\ni_PCI1710_InitCounter OK\n\n");

	if (b_CounterRange == 16) // 16 means PCI1710_16BIT_COUNTER
	{
		do
		{
			printf("Enter a compare logic value (0 to 0xFFFF (65535)): ");
			scanf_s("lu", &dw_Temp);
		} while (dw_Temp > 65535);
		dw_CompareLogicValue = dw_Temp;
	}
	else if (b_CounterRange == 0) // 0 means PCI1710_32BIT_COUNTER
	{
		do
		{
			printf("Enter a compare logic value (0 to 0xFFFFFFFF (4294967295)): ");
			scanf_s("%lu", &dw_Temp);
		} while (dw_Temp > 4294967295);
		dw_CompareLogicValue = dw_Temp;
	}

	i_ReturnValue = i_PCI1710_InitCompareLogic(h_BoardHandle, b_ModuleNbr, dw_CompareLogicValue);
	if (i_ReturnValue != 0)
		printf("\ni_PCI1710_InitCompareLogic error: %d\n", i_ReturnValue);

	i_ReturnValue = i_PCI1710_EnableCompareLogic(h_BoardHandle, b_ModuleNbr);
	if (i_ReturnValue != 0)
		printf("\ni_PCI1710_EnableCompareLogic error: %d\n", i_ReturnValue);

	printf("\n"
	       "****                                  ****\n"
	       "****   Press ESC to stop the sample   ****\n"
	       "****                                  ****\n\n");

	for (;;)
	{
		if (b_CounterRange == 16) // 16 means PCI1710_16BIT_COUNTER
		{
			i_ReturnValue = i_PCI1710_Read16BitCounterValue(h_BoardHandle, b_ModuleNbr, 0, &dw_FirstCounterReadValue);
			if (i_ReturnValue != 0)
			{
				printf("\ni_PCI1710_Read16BitCounterValue error: %d\n", i_ReturnValue);
				break;
			}

			i_ReturnValue = i_PCI1710_Read16BitCounterValue(h_BoardHandle, b_ModuleNbr, 1, &dw_SecondCounterReadValue);
			if (i_ReturnValue != 0)
			{
				printf("\ni_PCI1710_Read16BitCounterValue error: %d\n", i_ReturnValue);
				break;
			}

			printf("\rCurrent counter values: %-5u / %-5u", dw_FirstCounterReadValue, dw_SecondCounterReadValue);
		}
		else
		{
			i_ReturnValue = i_PCI1710_Read32BitCounterValue(h_BoardHandle, b_ModuleNbr, &dw_ValueRead);
			if (i_ReturnValue != 0)
			{
				printf("\ni_PCI1710_Read32BitCounterValue error: %d\n", i_ReturnValue);
				break;
			}

			printf("\rCurrent value of the counter: %-11lu", dw_ValueRead);
		}

		if (dw_OldInterruptCpt != dw_InterruptCpt)
		{
			printf("\n\nInterrupt received! Current count: %lu\n", dw_InterruptCpt);
			dw_OldInterruptCpt = dw_InterruptCpt;
			printf("\n");
		}

		if (_kbhit() && _getch() == VK_ESCAPE)
			break;
	}

cleanup:
	i_ReturnValue = i_PCI1710_DisableCompareLogic(h_BoardHandle, b_ModuleNbr);
	if (i_ReturnValue != 0)
		printf("\ni_PCI1710_DisableCompareLogic error: %d\n", i_ReturnValue);

	i_ReturnValue = i_PCI1710_ResetBoardIntRoutine(h_BoardHandle);
	if (i_ReturnValue == 0)
		printf("\ni_PCI1710_ResetBoardIntRoutine OK\n");
	else
		printf("\ni_PCI1710_ResetBoardIntRoutine error: %d\n", i_ReturnValue);

close:
	i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
	if (i_ReturnValue == 0)
		printf("\ni_PCI1710_CloseBoard OK\n");
	else
		printf("\ni_PCI1710_CloseBoard error: %d\n", i_ReturnValue);

end:
	printf("Press any key to exit the sample...");
	_getch();
	return 0;
}
