// CounterLatchInterrupt.cpp : Defines the entry point for the console application.
//



#include "stdafx.h"


DWORD dw_InterruptCpt = 0;
DWORD dw_IRQ_Status = 0;
DWORD dw_IRQ_InterruptSource = 0;
DWORD dw_IRQ_InterruptMask = 0;
DWORD dw_IRQ_LatchCounterValue = 0;
DWORD dw_IRQ_strobeACounter = 0;
DWORD dw_IRQ_strobeBCounter = 0;

VOID WINAPI v_FunctionName (HANDLE   h_DeviceHandle,
							DWORD   dw_Status,
                            DWORD   dw_InterruptSource,
                            DWORD   dw_InterruptMask,
                            DWORD   dw_ArgsSize,
                            PDWORD pdw_Args)

{
	UNREFERENCED_PARAMETER(h_DeviceHandle);
	UNREFERENCED_PARAMETER(dw_ArgsSize);

	dw_InterruptCpt = dw_InterruptCpt + 1;

	dw_IRQ_Status = dw_Status;
	dw_IRQ_InterruptSource = dw_InterruptSource;
	dw_IRQ_InterruptMask = dw_InterruptMask;
	dw_IRQ_LatchCounterValue = pdw_Args[0];

	if ((dw_IRQ_InterruptMask & 0x1) != 0)
		dw_IRQ_strobeACounter++;

	if ((dw_IRQ_InterruptMask & 0x2) != 0)
		dw_IRQ_strobeBCounter++;
}



int _tmain(int argc, _TCHAR* argv[])
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle;
	unsigned long dw_Temp = 0;
	unsigned char b_ModuleNbr = 0;
	unsigned char b_CounterRange = 0;
	unsigned char b_FirstCounterModus = 0;
	unsigned char b_FirstCounterOption = 0;
	unsigned char b_SecondCounterModus = 0;
	unsigned char b_SecondCounterOption = 0;
	unsigned char b_ExternaStrobeALevel = 0;
	unsigned char b_ExternaStrobeBLevel = 0;
	unsigned char b_Cpt = 0;
	unsigned char pb_CounterModeSelection [4] = {PCI1710_DIRECT_MODE,PCI1710_SIMPLE_MODE,PCI1710_DOUBLE_MODE,PCI1710_QUADRUPLE_MODE};
	char *pc_CounterModeSelection [4] = {"DIRECT_MODE","SIMPLE_MODE","DOUBLE_MODE","QUADRUPLE_MODE"};
	unsigned long dw_OldInterruptCpt = 0;
	UNREFERENCED_PARAMETER(argc);
	UNREFERENCED_PARAMETER(argv);
	

	printf("Test counter read write clear sample");

	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);

	if(i_ReturnValue ==0)
	{
		/* Install the interrupt routine */

		i_ReturnValue = i_PCI1710_SetBoardIntRoutine(h_BoardHandle,v_FunctionName);
		if (i_ReturnValue == 0)
		{
			printf("\n i_PCI1710_SetBoardIntRoutine OK");

			/* Get module number to test */
			do
			{
				printf("\n Select the module you want to use (0 to 3):");
				scanf_s("%lu",&dw_Temp);
			}
			while (dw_Temp > 3);

			b_ModuleNbr = (BYTE) dw_Temp;

			/* Get module range */
			do
			{
				printf("\n Select the module range(0: 1x32 bits or 1: 2x16bits) you want to use :");
				scanf_s("%lu",&dw_Temp);
			}
			while (dw_Temp > 1);

			b_CounterRange = (BYTE) dw_Temp << 4;

			if (b_CounterRange == PCI1710_16BIT_COUNTER)
			{
				printf("\n Select the counter mode for the first counter :");
				do
				{
					/* Get the counter mode */
					for (b_Cpt = 0; b_Cpt<4;b_Cpt++)
					{
						printf("\n%hu. %s",b_Cpt,pc_CounterModeSelection[b_Cpt]);
					}
					printf("\n Your selection :");
					scanf_s ("%lu",&dw_Temp);
				}
				while(dw_Temp > 3);

				b_FirstCounterModus = pb_CounterModeSelection[dw_Temp];

				printf("\n Select the first counter option :");

				if (b_FirstCounterModus == PCI1710_DIRECT_MODE)
				{
					do
					{
						printf("\n DECREMENT(0) or INCREMENT (1) :");
						scanf_s("%lu",&dw_Temp);
					}
					while(dw_Temp > 1);

					b_FirstCounterOption = (BYTE) (PCI1710_INCREMENT * dw_Temp);

				}
				else
				{
					do
					{
						printf("\n HYSTERESIS OFF(0) or HYSTERESIS ON (1) :");
						scanf_s("%lu",&dw_Temp);
					}
					while(dw_Temp > 1);

					b_FirstCounterOption = (BYTE) (PCI1710_HYSTERESIS_ON * dw_Temp);
				}


				printf("\n Select the counter mode for the second counter :");
				do
				{
					/* Get the counter mode */
					for (b_Cpt = 0; b_Cpt<4;b_Cpt++)
					{
						printf("\n%hu. %s",b_Cpt,pc_CounterModeSelection[b_Cpt]);
					}
					printf("\n Your selection :");
					scanf_s ("%lu",&dw_Temp);
				}
				while(dw_Temp > 3);

				b_SecondCounterModus = pb_CounterModeSelection[dw_Temp];

				printf("\n Select the second counter option :");

				if (b_SecondCounterModus == PCI1710_DIRECT_MODE)
				{
					do
					{
						printf("\n DECREMENT(0) or INCREMENT (1) :");
						scanf_s("%lu",&dw_Temp);
					}
					while(dw_Temp > 1);

					b_SecondCounterOption = (BYTE) (PCI1710_INCREMENT * dw_Temp);

				}
				else
				{
					do
					{
						printf("\n HYSTERESIS OFF(0) or HYSTERESIS ON (1) :");
						scanf_s("%lu",&dw_Temp);
					}
					while(dw_Temp > 1);

					b_SecondCounterOption = (BYTE) (PCI1710_HYSTERESIS_ON * dw_Temp);
				}

			}
			else
			{
				printf("\n Select the counter mode for the counter :");
				do
				{
					/* Get the counter mode */
					for (b_Cpt = 0; b_Cpt<4;b_Cpt++)
					{
						printf("\n%hu. %s",b_Cpt,pc_CounterModeSelection[b_Cpt]);
					}
					printf("\n Your selection :");
					scanf_s ("%lu",&dw_Temp);
				}
				while(dw_Temp > 3);

				b_FirstCounterModus = pb_CounterModeSelection[dw_Temp];

				printf("\n Select the counter option :");

				if (b_FirstCounterModus == PCI1710_DIRECT_MODE)
				{
					do
					{
						printf("\n DECREMENT(0) or INCREMENT (1) :");
						scanf_s("%lu",&dw_Temp);
					}
					while(dw_Temp > 1);

					b_FirstCounterOption = (BYTE) (PCI1710_INCREMENT * dw_Temp);

				}
				else
				{
					do
					{
						printf("\n HYSTERESIS OFF(0) or HYSTERESIS ON (1) :");
						scanf_s("%lu",&dw_Temp);
					}
					while(dw_Temp > 1);

					b_FirstCounterOption = (BYTE) (PCI1710_HYSTERESIS_ON * dw_Temp);
				}

				b_SecondCounterModus = 0;
				b_SecondCounterOption = 0;


			}


			/* Initialise the incremental counter */
			i_ReturnValue = i_PCI1710_InitCounter (h_BoardHandle,
				   								   b_ModuleNbr,
												   b_CounterRange,
												   b_FirstCounterModus,
												   b_FirstCounterOption,
												   b_SecondCounterModus,
												   b_SecondCounterOption);

			if (i_ReturnValue == 0)
			{
				printf("\n i_PCI1710_InitCounter OK");


				/* Get the external strobe A action level */
				do
				{
					printf ("\n\nGet the external strobe A action level");
					printf ("\n   0 : Low edge latch");
					printf ("\n   1 : High edge latch : ");
					scanf_s("%lu",&dw_Temp);
				}
				while(dw_Temp > 1);
				b_ExternaStrobeALevel = (BYTE) dw_Temp;


				/* Get the external strobe A action level */
				do
				{
					printf ("\n\nGet the external strobe B action level");
					printf ("\n   0 : Low edge latch");
					printf ("\n   1 : High edge latch : ");
					scanf_s("%lu",&dw_Temp);
				}
				while(dw_Temp > 1);
				b_ExternaStrobeBLevel = (BYTE) dw_Temp;

				/* Set the external strobe A action level */
				i_ReturnValue = i_PCI1710_InitExternalStrobe (h_BoardHandle,
															  b_ModuleNbr,
															  0,
															  b_ExternaStrobeALevel);
				if (i_ReturnValue == 0)
				{
					printf("\n i_PCI1710_InitExternalStrobe A OK");
					
					/* Set the external strobe B action level */
					i_ReturnValue = i_PCI1710_InitExternalStrobe (h_BoardHandle,
																  b_ModuleNbr,
																  1,
																  b_ExternaStrobeBLevel);
					if (i_ReturnValue == 0)
					{
						printf("\n i_PCI1710_InitExternalStrobe A OK");
						
						/* Enable the extern latch interrupt */
						i_ReturnValue = i_PCI1710_EnableLatchInterrupt (h_BoardHandle,b_ModuleNbr);

						if (i_ReturnValue == 0)
						{
							printf("\n i_PCI1710_EnableLatchInterrupt OK");
							printf("\n Wait for interrupt ...");
							for (;;)
							{
								if (dw_OldInterruptCpt != dw_InterruptCpt)
								{
									printf("\nIRQ Cpt:%lu FIFO Over:%lu IRQ src:%lu IRQ mask:%lu Counter value:%lu strobe A Counter:%lu strobe B Counter:%lu ",
										   dw_InterruptCpt,
										   dw_IRQ_Status,
										   dw_IRQ_InterruptSource,
										   dw_IRQ_InterruptMask, 
										   dw_IRQ_LatchCounterValue,
										   dw_IRQ_strobeACounter,
										   dw_IRQ_strobeBCounter);

									/* Print the interrupt information */
									dw_OldInterruptCpt = dw_InterruptCpt;
								}



								if (_kbhit ())
								{
									/* Test ESC */
									if (_getch () == 27)
										break;
								}
							} 
							i_ReturnValue = i_PCI1710_DisableLatchInterrupt (h_BoardHandle,b_ModuleNbr);	
							if(i_ReturnValue == 0)
								printf("\n i_PCI1710_DisableLatchInterrupt OK");
							else
								printf("\n i_PCI1710_DisableLatchInterrupt Error : %d",i_ReturnValue);


						}
						else
						{
							printf("\n i_PCI1710_EnableLatchInterrupt Error = %d",i_ReturnValue);
						}

					}
					else
					{
						printf("\n i_PCI1710_InitExternalStrobe B Error : %d", i_ReturnValue);
					}
				}
				else
				{
					printf("\n i_PCI1710_InitExternalStrobe A Error : %d", i_ReturnValue);
				}

			}
			else
			{
				printf("\n i_PCI1710_InitCounter Error : %d", i_ReturnValue);
			}

			i_ReturnValue = i_PCI1710_ResetBoardIntRoutine(h_BoardHandle);
			if (i_ReturnValue == 0)
				printf("\n i_PCI1710_ResetBoardIntRoutine OK");
			else
				printf("\n i_PCI1710_ResetBoardIntRoutine Error : %d",i_ReturnValue);

		}
		else
		{
			printf("\n i_PCI1710_SetBoardIntRoutine Error : %d", i_ReturnValue);
		}
		i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
		if (i_ReturnValue == 0)
			printf("\n i_PCI1710_CloseBoard OK");
		else
			printf("\n i_PCI1710_CloseBoard Error : %d",i_ReturnValue);

	}

	printf("\n Press any key to exit the sample ...");
	_getch();
	


	return 0;
}

