#include "stdafx.h"

/* Device handle of the board */
HANDLE _h_DeviceHandle        = NULL;

void __stdcall v_InterruptRoutine(HANDLE   h_DeviceHandle,
								  DWORD   dw_Status,
								  DWORD   dw_InterruptSource,
								  DWORD   dw_InterruptMask,
								  DWORD   dw_ArgsSize,
								  PDWORD pdw_Args)
{
	UNREFERENCED_PARAMETER(dw_ArgsSize);
	UNREFERENCED_PARAMETER(pdw_Args);
	UNREFERENCED_PARAMETER(dw_Status);

	int i = 0, j = 0;

	/* Test if sample interrupt */
	if (h_DeviceHandle != _h_DeviceHandle)
		return;

	if (dw_Status != 0)
		printf("\nFIFO overflow");
		
	for (i = 0; i < 4; i++)
		if ((dw_InterruptSource >> i)  != 0)
			for (j = 0; j < 4; j++)
				if (((dw_InterruptMask >> j) & 0x1) != 0)
					printf("\nModule %d Pulse counter %d interrupt", i, j);
}

int _tmain(int argc, _TCHAR* argv[])
{
	int i_ReturnValue            = 0;
	DWORD  dw_Temp               = 0;
	BYTE   b_ModuleNbr           = 0;
    BYTE   b_PulseEncoderNbr     = 0;
    BYTE   b_InputLevelSelection = 0;
    BYTE   b_TriggerOutputAction = 0;
    ULONG  dw_StartValue         = 0;
    BYTE   b_CycleSelection      = 0;
    BYTE   b_InterruptHandling   = 0;

	UNREFERENCED_PARAMETER(argc);
	UNREFERENCED_PARAMETER(argv);

	printf("\nTest pulse encoder sample\n");
	i_ReturnValue = i_Utils_OpenBoard(&_h_DeviceHandle);
	if(i_ReturnValue != 0)
		exit(-1);

	do
	{
		printf("\nSelect the module you want to use (0 to 3):");
		scanf_s("%lu",&dw_Temp);
	}
	while (dw_Temp > 3);
	b_ModuleNbr = (BYTE) dw_Temp;

	do
	{
		printf("\nSelect the pulse encoder number you want to use (0 to 3):");
		scanf_s("%lu",&dw_Temp);
	}
	while (dw_Temp > 3);
	b_PulseEncoderNbr = (BYTE) dw_Temp;

	do
	{
		printf("\nSelect the input level selection"
			   "\n\t0: Set pulse encoder count at low edges"
			   "\n\t1: Set pulse encoder count at high edges");
		scanf_s("%lu",&dw_Temp);
	}
	while (dw_Temp > 1);
	b_InputLevelSelection = (BYTE) dw_Temp;

	do
	{
		printf("\nSelect the digital trigger output action"
			   "\n\t0: No action"
			   "\n\t1: Set the trigger output to 1"
			   "\n\t2: Set the trigger output to 0 (low) after the passage from 1 to 0 from pulse");
		scanf_s("%lu",&dw_Temp);
	}
	while (dw_Temp > 2);
	b_TriggerOutputAction = (BYTE) dw_Temp;

	do
	{
		printf("\nSelect the start value (1 to 4294967295)");
		scanf_s("%lu",&dw_Temp);
	}
	while (dw_Temp < 1);
	dw_StartValue = dw_Temp;

	do
	{
		printf("\nSelect cycle selection (0 : APCI1710_SINGLE, 1 : APCI1710_CONTINUOUS)");
		scanf_s("%lu",&dw_Temp);
	}
	while (dw_Temp > 1);
	b_CycleSelection = (BYTE) dw_Temp;

	do
	{
		printf("\nDo you want to enable interrupt ? (1 : APCI1710_ENABLE, 0 : APCI1710_DISABLE)");
		scanf_s("%lu",&dw_Temp);
	}
	while (dw_Temp > 1);
	b_InterruptHandling = (BYTE) dw_Temp;

	if (b_InterruptHandling != 0)
	{
		i_ReturnValue = i_PCI1710_SetBoardIntRoutine(_h_DeviceHandle, &v_InterruptRoutine);
		if (i_ReturnValue != 0)
			{ printf("\ni_PCI1710_SetBoardIntRoutine error %d", i_ReturnValue); goto sample_end; }
	}

	i_ReturnValue = i_PCI1710_InitPulseEncoder(_h_DeviceHandle,
											   b_ModuleNbr,
											   b_PulseEncoderNbr,
											   b_InputLevelSelection,
											   b_TriggerOutputAction,
											   dw_StartValue);
	if (i_ReturnValue != 0)
		{ printf("\ni_PCI1710_InitPulseEncoder error %d", i_ReturnValue); goto sample_end; }

	i_ReturnValue = i_PCI1710_EnablePulseEncoder(_h_DeviceHandle, b_ModuleNbr, b_PulseEncoderNbr, b_CycleSelection, b_InterruptHandling);
	if (i_ReturnValue != 0)
		{ printf("\ni_PCI1710_EnablePulseEncoder error %d", i_ReturnValue); goto sample_end; }

	printf("\nSelect an operation:"
			"\n\t\'r\' Read pulse encoder value"
			"\n\t\'s\' Read pulse encoder status"
			"\n\t\'w\' Write pulse encoder value (only in single mode)"
			"\n\tother key exit the sample");
	for(;;)
	{
		int key = _getch();
		ULONG dw_WriteValue = 0;
		ULONG dw_ReadValue  = 0;
		BYTE  b_Status      = 0;
		switch(key)
		{
		case 'r':
			i_ReturnValue = i_PCI1710_ReadPulseEncoderValue(_h_DeviceHandle, b_ModuleNbr, b_PulseEncoderNbr, &dw_ReadValue);
			if (i_ReturnValue != 0)
				{ printf("i_PCI1710_ReadPulseEncoderValue error %d", i_ReturnValue); goto sample_end; }
			printf("\ni_PCI1710_ReadPulseEncoderValue = %d", dw_ReadValue);
			break;
		case 's':
			i_ReturnValue = i_PCI1710_ReadPulseEncoderStatus(_h_DeviceHandle, b_ModuleNbr, b_PulseEncoderNbr, &b_Status);
			if (i_ReturnValue != 0)
				{ printf("i_PCI1710_ReadPulseEncoderStatus error %d", i_ReturnValue); goto sample_end; }
			printf("\ni_PCI1710_ReadPulseEncoderStatus = %d", b_Status);
			break;
		case 'w':
			if (b_CycleSelection == 0)
			{
				printf("\nSelect write value: ");
				scanf_s("%lu",&dw_WriteValue);
				dw_WriteValue = i_PCI1710_WritePulseEncoderValue(_h_DeviceHandle, b_ModuleNbr, b_PulseEncoderNbr, dw_WriteValue);
				if (i_ReturnValue != 0)
					{ printf("i_PCI1710_WritePulseEncoderValue error %d", i_ReturnValue); goto sample_end; }
			}
			break;
		default :
			goto sample_end;
		}
	}

sample_end:
	i_ReturnValue = i_PCI1710_DisablePulseEncoder(_h_DeviceHandle, b_ModuleNbr, b_PulseEncoderNbr);
	if (i_ReturnValue != 0)
		printf("\ni_PCI1710_DisablePulseEncoder error %d", i_ReturnValue);

	if (b_InterruptHandling != 0)
	{
		i_ReturnValue = i_PCI1710_ResetBoardIntRoutine(_h_DeviceHandle);
		if (i_ReturnValue != 0)
			printf("\ni_PCI1710_ResetBoardIntRoutine error %d", i_ReturnValue);
	}

	i_ReturnValue = i_PCI1710_CloseBoard(_h_DeviceHandle);
	if (i_ReturnValue != 0)
		printf("\ni_PCI1710_CloseBoard error %d", i_ReturnValue);

	printf("\n Press any key to exit the sample ...");
	_getch();
	
	return 0;
}

