// GetSSIValue.cpp : Defines the entry point for the console application.
//


#include "stdafx.h"


int _tmain(int argc, _TCHAR* argv[])
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle = NULL;
	BYTE b_Module = 0;
	BYTE b_SSINbr = 0;
	BYTE b_PCIInputClk = 0;
	BYTE b_Status = 1;
	DWORD dw_OutputClk = 0;
	BYTE b_Mode = 0;
	DWORD dw_Pos = 0;
	DWORD dw_Turn = 0;
	DWORD dw_Temp = 0;

	printf("Get SSI value test sample");
	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);

	if(i_ReturnValue == 0)
	{
		/*Initialization of the parameters*/

		/*Set the module*/
		do
		{
			_flushall();
			printf("\nSelect the module (0 to 3) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 3);

		b_Module = (BYTE)dw_Temp;
		
		/*Set the counter number*/
		do
		{
			_flushall();
			printf("\nSelect the number of the counter (0 to 2) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 2);

		b_SSINbr = (BYTE)dw_Temp;

		/*Set the input clock*/
		do
		{
			_flushall();
			printf("\nSelect the input clock (30MHz or 33MHz) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp != 30 && dw_Temp != 33);

		b_PCIInputClk = (BYTE)dw_Temp;


		/*Set the output clock*/
		if(b_PCIInputClk == 30)
		{
			do
			{
				_flushall();
				printf("\nSelect the output clock in Hz (229 to 500000) : ");
				scanf_s("%u", &dw_OutputClk);
			}
			while(dw_OutputClk < 229 || dw_OutputClk > 500000);
		}
		else
		{
			do
			{
				_flushall();
				printf("\nSelect the output clock in Hz (252 to 500000) : ");
				scanf_s("%u", &dw_OutputClk);
			}
			while(dw_OutputClk < 252 || dw_OutputClk > 500000);
		}

		/*Set mode */
		do
		{
			_flushall();
			printf("\nSelect the mode (0 -> raw, 1 -> translated) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 1);

		b_Mode = (BYTE)dw_Temp;

		if(b_Mode == 1)
		{
			/*Initialize the SSI*/
			i_ReturnValue = i_PCI1710_InitSSI(h_BoardHandle,	
												b_Module,		 
												24,			//number of bits for profile
												12,			//length of encoding for position
												12,			//length of encoding for turns
												b_PCIInputClk,		
												dw_OutputClk, 
												1);			//binary encoding
		}
		else
		{
			i_ReturnValue = i_PCI1710_InitSSIRawData(h_BoardHandle, 
													b_Module, 
													24, 
													b_PCIInputClk, 
													dw_OutputClk);
		}

		if(i_ReturnValue == 0)
		{
			/*SSI initialized*/
			printf("\n Press ESC to exit");

			for(;;)
			{
				if(_kbhit())
					if(_getch() == 27)
						break;

				i_ReturnValue = i_PCI1710_StartSSIAcquisition(h_BoardHandle, b_Module);

				if(i_ReturnValue == 0)
				{
					do
					{
						i_ReturnValue = i_PCI1710_GetSSIAcquisitionStatus(h_BoardHandle, 
																		b_Module, 
																		&b_Status);

						if(i_ReturnValue != 0)
						{
							printf("\n i_PCI1710_GetSSIAcquisitionStatus Error : %d", i_ReturnValue);
							break;
						}
					}
					while(b_Status != 0);

					if(b_Mode == 1 && b_Status == 0)
					{
						i_ReturnValue = i_PCI1710_GetSSIValue(h_BoardHandle, 
																b_Module, 
																b_SSINbr, 
																&dw_Pos, 
																&dw_Turn);

						if(i_ReturnValue == 0)
						{
							printf("\n Position : 0x%x, Turn : 0x%x", dw_Pos, dw_Turn);
						}
						else 
						{
							printf("\n i_PCI1710_GetSSIValue Error : %d", i_ReturnValue);
						}
					}
					else if(b_Status == 0)
					{
						i_ReturnValue = i_PCI1710_GetSSIRawDataValue(h_BoardHandle, 
																	b_Module, 
																	b_SSINbr, 
																	&dw_Pos, 
																	1);

						if(i_ReturnValue == 0)
						{
							printf("\n Raw value : 0x%x", dw_Pos);
						}
						else 
						{
							printf("\n i_PCI1710_GetSSIRawDataValue Error : %d", i_ReturnValue);
						}
					}
				}
				else
				{
					printf("\n i_PCI1710_StartSSIAcquisition Error : %d", i_ReturnValue);
				}
			}
		}
		else
		{
			printf("\n i_PCI1710_InitSSI Error : %d", i_ReturnValue);
		}


		i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
	}
	else
	{
		printf("\n i_PCI1710_InitTimer Error : %d", i_ReturnValue);
	}

	printf("\n Press any key to exit the sample ...");
	_getch();
	


	return 0;
}

