// ReadAllSSIValue.cpp : Defines the entry point for the console application.
//



#include "stdafx.h"


int _tmain(int argc, _TCHAR* argv[])
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle = NULL;
	BYTE b_Module = 0;
	BYTE b_Profile = 0;
	BYTE b_PosLen = 0;
	BYTE b_TurnLen = 0;
	BYTE b_PCIInputClk = 0;
	DWORD dw_OutputClk = 0;
	BYTE b_Mode = 0;
	DWORD pdw_Pos[3] = {0, 0, 0};
	DWORD pdw_Turn[3] = {0, 0, 0};
	DWORD dw_Temp = 0;

	printf("Read all SSI value test sample");
	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);

	if(i_ReturnValue == 0)
	{
		/*Initialization of the parameters*/

		/*Set the module*/
		do
		{
			_flushall();
			printf("\nSelect the module (0 to 3) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 3);

		b_Module = (BYTE)dw_Temp;

		/*Set the profile length*/
		do
		{
			_flushall();
			printf("\nSelect the profile length in bits (2 to 32) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp < 2 || dw_Temp > 32);

		b_Profile = (BYTE)dw_Temp;

		/*Set the position length*/
		do
		{
			_flushall();
			printf("\nSelect the position length in bits (1 to %d) : ", b_Profile);
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp < 1 || dw_Temp > (DWORD)b_Profile);

		b_PosLen = (BYTE)dw_Temp;

		/*Set the turn length*/
		do
		{
			_flushall();
			printf("\nSelect the turn length in bits (0 to %d) : ", b_Profile - b_PosLen);
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > (DWORD)(b_Profile - b_PosLen));

		b_TurnLen = (BYTE)dw_Temp;

		/*Set the input clock*/
		do
		{
			_flushall();
			printf("\nSelect the input clock (30MHz or 33MHz) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp != 30 && dw_Temp != 33);

		b_PCIInputClk = (BYTE)dw_Temp;


		/*Set the output clock*/
		if(b_PCIInputClk == 30)
		{
			do
			{
				_flushall();
				printf("\nSelect the output clock in Hz (229 to 500000) : ");
				scanf_s("%u", &dw_OutputClk);
			}
			while(dw_OutputClk < 229 || dw_OutputClk > 500000);
		}
		else
		{
			do
			{
				_flushall();
				printf("\nSelect the output clock in Hz (252 to 500000) : ");
				scanf_s("%u", &dw_OutputClk);
			}
			while(dw_OutputClk < 252 || dw_OutputClk > 500000);
		}

		/*Set the counting mode*/
		do
		{
			_flushall();
			printf("\nSelect the counting mode :");
			printf("\n       0 -> No conversion is made (raw value is delivered),");
			printf("\n       1 -> A conversion from gray code to binary is made");
			printf("\n       : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 1);

		b_Mode = (BYTE)dw_Temp;

		/*Initialize the SSI*/
		i_ReturnValue = i_PCI1710_InitSSI(h_BoardHandle,	
											b_Module,		 
											b_Profile,			//number of bits for profile
											b_PosLen,			//length of encoding for position
											b_TurnLen,			//length of encoding for turns
											b_PCIInputClk,		
											dw_OutputClk, 
											b_Mode);			//binary or gray emcoding

		if(i_ReturnValue == 0)
		{
			/*SSI initialized*/

			printf("\n Press ESC to quit");

			for(;;)
			{
				i_ReturnValue = i_PCI1710_ReadAllSSIValue(h_BoardHandle, 
														b_Module, 
														pdw_Pos,
														pdw_Turn);

				if(i_ReturnValue != 0)
				{
					printf("\n i_PCI1710_ReadAllSSIValue Error : %d", i_ReturnValue);
					break;
				}
				
				printf("\n 0. %d %d \t 1. %d %d \t 2. %d %d", 
						pdw_Turn[0],
						pdw_Pos[0], 
						pdw_Turn[1],
						pdw_Pos[1],
						pdw_Turn[2], 
						pdw_Pos[2]);

				if(_kbhit())
					if(_getch() == 27)
						break;
			}
		}
		else
		{
			printf("\n i_PCI1710_InitSSI Error : %d", i_ReturnValue);
		}

		
		i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
	}
	else
	{
		printf("\n i_PCI1710_InitTimer Error : %d", i_ReturnValue);
	}

	printf("\n Press any key to exit the sample ...");
	_getch();
	


	return 0;
}

