// ReadSSIDigtalInput.cpp : Defines the entry point for the console application.
//



#include "stdafx.h"


int _tmain(int argc, _TCHAR* argv[])
{
	int i_ReturnValue = 0;
	HANDLE h_BoardHandle = NULL;
	BYTE b_Module = 0;
	BYTE b_Status = 0;
	DWORD dw_Temp = 0;
	CHAR c_Key = 0;

	printf("Read SSI digital input test sample");
	i_ReturnValue = i_Utils_OpenBoard(&h_BoardHandle);

	if(i_ReturnValue ==0)
	{
		/*Initialization of the parameters*/

		/*Set the module*/
		do
		{
			_flushall();
			printf("\nSelect the module (0 to 3) : ");
			scanf_s("%u", &dw_Temp);
		}
		while(dw_Temp > 3);

		b_Module = (BYTE)dw_Temp;
		
		/*Initialise the SSI. Here values does not realy care, beacause we want to test the inputs*/
		i_ReturnValue = i_PCI1710_InitSSI(h_BoardHandle, 
										b_Module, 
										24,				//profile length
										12,				//position length
										12,				//turn counter length
										30,				//PCI clock
										200000,			//output clock
										0);				//binary mode

		if(i_ReturnValue == 0)
		{
			printf("\n Press ESC to quit, R to read channel 0, A to read all channels");
			for(;;)
			{
				c_Key = (CHAR)_getch();

				if(c_Key == 27)
					break;
				else if(c_Key == 'r' || c_Key == 'R')
				{
					/*Read channel 0*/
					i_ReturnValue = i_PCI1710_ReadSSI1DigitalInput(h_BoardHandle, 
																	b_Module, 
																	0,			//channel 0
																	&b_Status);

					if(i_ReturnValue == 0)
						printf("\n channel 0 : %d", b_Status);
					else
					{
						printf("\n i_PCI1710_ReadSSI1DigitalInput Error : %d", i_ReturnValue);
						break;
					}
				}
				else if(c_Key == 'a' || c_Key == 'A')
				{
					/*Read all channels*/
					i_ReturnValue = i_PCI1710_ReadSSIAllDigitalInput(h_BoardHandle, 
																	b_Module, 
																	&b_Status);

					if(i_ReturnValue == 0)
						printf("\n Inputs value : %d", b_Status);
					else
					{
						printf("\n i_PCI1710_ReadSSIAllDigitalInput Error : %d", i_ReturnValue);
						break;
					}
				}
			}
		}
		else
		{
			printf("\n i_PCI1710_InitSSI Error : %d", i_ReturnValue);
		}

		i_ReturnValue = i_PCI1710_CloseBoard(h_BoardHandle);
	}
	else
	{
		printf("\n i_PCI1710_InitTimer Error : %d", i_ReturnValue);
	}

	printf("\n Press any key to exit the sample ...");
	_getch();
	


	return 0;
}

