#include "stdafx.h"

int i_Utils_OpenBoard(HANDLE * ph_BoardHandle)
{
	unsigned char b_NbrOfBoard = 0;
	unsigned char b_Cpt = 0;
	unsigned char b_Board = 0;
	unsigned long dw_Temp = 0;
	unsigned long dw_OpenMode = 0;
	int i_ReturnValue = 0;
	char pc_Identifier[50];
	char *pc_OpenFunction[2] = {"i_PCI1710_OpenBoardViaIndex","i_PCI1710_OpenBoardViaIdentifier"};
	unsigned long ul_UINumber;
	unsigned long ul_DeviceNumber;
	unsigned long ul_BusNumber;
	unsigned long ul_Address0;
	unsigned long ul_Address1;
	unsigned char b_Interrupt;
	unsigned long dw_Version = 0;

	if(i_PCI1710_GetDLLVersion(&dw_Version) == 0)
		printf("\n DLL version : %d.%d",(dw_Version >> 24) & 0xFF, (dw_Version >> 16) & 0xFF );

	i_ReturnValue = i_PCI1710_GetNumberOfBoards(&b_NbrOfBoard);

	if(i_ReturnValue ==0)
	{
		printf("\n i_PCI1710_GetNumberOfBoards OK");
		printf("\n Nbr of board found : %d \n",b_NbrOfBoard);

		if (b_NbrOfBoard > 0)
		{

			for (b_Cpt = 0; b_Cpt < b_NbrOfBoard;b_Cpt ++)
			{
				i_ReturnValue = i_PCI1710_GetBoardInformation(b_Cpt,pc_Identifier,50,&ul_UINumber,&ul_DeviceNumber,&ul_BusNumber,&ul_Address0,&ul_Address1,&b_Interrupt);

				if (i_ReturnValue == 0)
				{
					printf("\n\n Board %hu information :",b_Cpt);
					printf("\n Identifier : %s",pc_Identifier);
					printf("\n UI number : 0x%lx",ul_UINumber);
					printf("\n Device number : 0x%lx",ul_DeviceNumber);
					printf("\n Bus number : 0x%lx",ul_BusNumber);
					printf("\n Base address 0 : 0x%lx",ul_Address0);
					printf("\n Base address 1 : 0x%lx",ul_Address1);
					printf("\n Interrupt : %hu",b_Interrupt);

				}
			}

			do
			{
				printf("\n Do you want to open the driver via index (0) or via identifier (1):");
				scanf_s("%lu",&dw_OpenMode);
			}
			while(dw_OpenMode > 1);

			if(dw_OpenMode == 0)
			{

				do
				{
					printf("\n Select the board you want to use (0 to %d):",b_NbrOfBoard-1);
					scanf_s("%lu",&dw_Temp);
				}
				while (dw_Temp >= b_NbrOfBoard);

				b_Board = (BYTE)dw_Temp;
			}
			else
			{
				printf("\n Enter the board identifier :");
				scanf_s("%s",pc_Identifier);
			}


			if (dw_OpenMode == 0)
				i_ReturnValue = i_PCI1710_OpenBoardViaIndex(b_Board,ph_BoardHandle);
			else
				i_ReturnValue = i_PCI1710_OpenBoardViaIdentifier(pc_Identifier,ph_BoardHandle);

			if (i_ReturnValue == 0)
			{
				printf("\n %s OK",pc_OpenFunction[dw_OpenMode]);
				if(i_PCI1710_GetDeviceDriverVersion(*ph_BoardHandle,&dw_Version) == 0)
					printf("\n Device driver version : %d.%d",(dw_Version >> 24) & 0xFF, (dw_Version >> 16) & 0xFF );

			}
			else
			{
				printf("\n %s Error : %d", pc_OpenFunction[dw_OpenMode], i_ReturnValue);
			}
		}
		else
		{
			i_ReturnValue = -1;
		}
	}
	else
		printf("\n i_PCI1710_GetNumberOfBoards Error : %d",i_ReturnValue);
	
	return (i_ReturnValue);
}