using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace CounterReadWriteClear
{
    public partial class CounterReadWriteClear : Form
    {
        private byte moduleNbr;
        private byte counterRange;
        private byte mode;
        private byte mode1;
        private byte option;
        private byte option1;

        /// <summary>
        /// Handle to the first board
        /// </summary>
        PCI1710_NET.PCI1710 board;

        /// <summary>
        /// Constructor of the form
        /// </summary>
        public CounterReadWriteClear()
        {
            InitializeComponent();
            this.moduleNbr = 0;
            this.counterRange = 0;
            this.mode = 0;
            this.mode1 = 0;
            this.option = 0;
            this.option1 = 0;
        }


        private void CounterReadWriteClear_Load(object sender, EventArgs e)
        {
            // Open the first board of the system
            this.board = PCI1710_NET.PCI1710.OpenBoard(0);
            // Error handling
            if (this.board == null)
            {
                MessageBox.Show("Error OpenBoard returned null");
                this.Close();
                return;
            }
            module0.Enabled = true;
        }

        private void CounterReadWriteClear_FormClosing(object sender, EventArgs e)
        {

        }

        private void module0_CheckedChanged(object sender, EventArgs e)
        {
            if (module0.Checked == true)
            {
                moduleNbr = 0;
                module.Visible = true;
            }
        }

        private void module1_CheckedChanged(object sender, EventArgs e)
        {
            if (module1.Checked == true)
            {
                moduleNbr = 1;
                module.Visible = true;
            }
        }

        private void module2_CheckedChanged(object sender, EventArgs e)
        {
            if (module2.Checked == true)
            {
                moduleNbr = 2;
                module.Visible = true;
            }
        }

        private void module3_CheckedChanged(object sender, EventArgs e)
        {
            if (module3.Checked == true)
            {
                moduleNbr = 3;
                module.Visible = true;
            }
        }

        private void oneCounter_CheckedChanged(object sender, EventArgs e)
        {
            if (oneCounter.Checked == true)
            {
                counterRange = 0;
                label5.Text = "Counter current value:";
                label12.Text = "Counter mode:";
                label13.Text = "Counter option:";
                clearButton.Text = "Clear";
                writeButton.Text = "Write";
                counterCurrentValue.Text = "0";
                writeValue.Maximum = 4294967295;
                groupBox1CounterMode.Visible = true;
                groupBox1CounterOption.Visible = true;
                groupBox2CountersMode.Visible = false;
                groupBox2CountersOption.Visible = false;
                label5.Visible = true;
                label7.Visible = false;
                label12.Visible = true;
                label13.Visible = true;
                counterCurrentValue.Visible = true;
                clearButton.Visible = true;
                writeButton.Visible = true;
                writeValue.Visible = true;
                writeValue1.Visible = false;
                initButton.Visible = true;

            }
            else
            {
                label5.Text = "Counter 0 current value:";
                label12.Text = "Counter 0 mode:";
                label13.Text = "Counter 0 option:";
                clearButton.Text = "Clear 0";
                writeButton.Text = "Write 0";
                counterCurrentValue.Text = "0";
                writeValue.Maximum = 65535;
                groupBox1CounterMode.Visible = true;
                groupBox1CounterOption.Visible = true;
                groupBox2CountersMode.Visible = true;
                groupBox2CountersOption.Visible = true;
                label5.Visible = true;
                label7.Visible = false;
                label12.Visible = true;
                label13.Visible = true;
                counterCurrentValue.Visible = false;
                clearButton.Visible = true;
                writeButton.Visible = true;
                writeValue.Visible = true;
                writeValue1.Visible = true;
                initButton.Visible = true;
            }
        }

        private void twoCounters_CheckedChanged(object sender, EventArgs e)
        {
            if (twoCounters.Checked == true)
            {
                counterRange = 16;
                groupBox2CountersMode.Visible = true;
                groupBox2CountersOption.Visible = true;
                label5.Text = "Counter 0 current value:";
                label12.Text = "Counter 0 mode:";
                label13.Text = "Counter 0 option:";
                clearButton.Text = "Clear 0";
                writeButton.Text = "Write 0";
                counterCurrentValue.Text = "0";
                groupBox1CounterMode.Visible = true;
                groupBox1CounterOption.Visible = true;
                label4.Visible = true;
                label5.Visible = true;
                label7.Visible = true;
                label12.Visible = true;
                label13.Visible = true;
                label14.Visible = true;
                counterCurrentValue.Visible = true;
                clearButton.Visible = true;
                writeButton.Visible = true;
                label7.Visible = true;
                counter1CurrentValue.Visible = true;
                writeButton1.Visible = true;
                writeValue.Visible = true;
                writeValue1.Visible = true;
                initButton.Visible = true;
            }
            else
            {
                groupBox2CountersMode.Visible = false;
                groupBox2CountersOption.Visible = false;
                label5.Text = "Counter current value:";
                label12.Text = "Counter mode:";
                label13.Text = "Counter option:";
                clearButton.Text = "Clear";
                writeButton.Text = "Write";
                counterCurrentValue.Text = "0";
                groupBox1CounterMode.Visible = true;
                groupBox1CounterOption.Visible = true;
                label5.Visible = true;
                label7.Visible = false;
                label12.Visible = true;
                label13.Visible = true;
                label14.Visible = false;
                counterCurrentValue.Visible = true;
                clearButton.Visible = true;
                writeButton.Visible = true;
                label7.Visible = false;
                counter1CurrentValue.Visible = false;
                writeButton1.Visible = false;
                writeValue.Visible = true;
                writeValue1.Visible = false;
                initButton.Visible = true;
            }
        }

        private void directMode_CheckedChanged(object sender, EventArgs e)
        {
            if (directMode.Checked == true)
            {
                mode = 128;
                incrementOption.Enabled = true;
                decrementOption.Enabled = true;
                hysteresisOnOption.Enabled = false;
                hysteresisOffOption.Enabled = false;
            }
            else
            {
                incrementOption.Enabled = false;
                decrementOption.Enabled = false;
                hysteresisOnOption.Enabled = true;
                hysteresisOffOption.Enabled = true;
            }
        }

        private void simpleMode_CheckedChanged(object sender, EventArgs e)
        {
            if (simpleMode.Checked == true)
            {
                mode = 15;
                incrementOption.Enabled = false;
                decrementOption.Enabled = false;
                hysteresisOnOption.Enabled = true;
                hysteresisOffOption.Enabled = true;
            }
            else
            {
                incrementOption.Enabled = true;
                decrementOption.Enabled = true;
                hysteresisOnOption.Enabled = false;
                hysteresisOffOption.Enabled = false;
            }
        }

        private void doubleMode_CheckedChanged(object sender, EventArgs e)
        {
            if (doubleMode.Checked == true)
            {
                mode = 3;
                incrementOption.Enabled = false;
                decrementOption.Enabled = false;
                hysteresisOnOption.Enabled = true;
                hysteresisOffOption.Enabled = true;
            }
            else
            {
                incrementOption.Enabled = true;
                decrementOption.Enabled = true;
                hysteresisOnOption.Enabled = false;
                hysteresisOffOption.Enabled = false;
            }
        }

        private void quadrupleMode_CheckedChanged(object sender, EventArgs e)
        {
            mode = 0;
            if (quadrupleMode.Checked == true)
            {
                incrementOption.Enabled = false;
                decrementOption.Enabled = false;
                hysteresisOnOption.Enabled = true;
                hysteresisOffOption.Enabled = true;
            }
            else
            {
                incrementOption.Enabled = true;
                decrementOption.Enabled = true;
                hysteresisOnOption.Enabled = false;
                hysteresisOffOption.Enabled = false;
            }
        }

        private void directMode1_CheckedChanged(object sender, EventArgs e)
        {
            if (directMode1.Checked == true)
            {
                mode1 = 128;
                incrementOption1.Enabled = true;
                decrementOption1.Enabled = true;
                hysteresisOnOption1.Enabled = false;
                hysteresisOffOption1.Enabled = false;
            }
            else
            {
                incrementOption1.Enabled = false;
                decrementOption1.Enabled = false;
                hysteresisOnOption1.Enabled = true;
                hysteresisOffOption1.Enabled = true;
            }
        }

        private void simpleMode1_CheckedChanged(object sender, EventArgs e)
        {
            if (simpleMode1.Checked == true)
            {
                mode1 = 15;
                incrementOption1.Enabled = false;
                decrementOption1.Enabled = false;
                hysteresisOnOption1.Enabled = true;
                hysteresisOffOption1.Enabled = true;
            }
            else
            {
                incrementOption1.Enabled = true;
                decrementOption1.Enabled = true;
                hysteresisOnOption1.Enabled = false;
                hysteresisOffOption1.Enabled = false;
            }
        }

        private void doubleMode1_CheckedChanged(object sender, EventArgs e)
        {
            if (doubleMode1.Checked == true)
            {
                mode1 = 3;
                incrementOption1.Enabled = false;
                decrementOption1.Enabled = false;
                hysteresisOnOption1.Enabled = true;
                hysteresisOffOption1.Enabled = true;
            }
            else
            {
                incrementOption1.Enabled = true;
                decrementOption1.Enabled = true;
                hysteresisOnOption1.Enabled = false;
                hysteresisOffOption1.Enabled = false;
            }
        }

        private void quadrupleMode1_CheckedChanged(object sender, EventArgs e)
        {
            if (quadrupleMode1.Checked == true)
            {
                mode1 = 0;
                incrementOption1.Enabled = false;
                decrementOption1.Enabled = false;
                hysteresisOnOption1.Enabled = true;
                hysteresisOffOption1.Enabled = true;
            }
            else
            {
                incrementOption1.Enabled = true;
                decrementOption1.Enabled = true;
                hysteresisOnOption1.Enabled = false;
                hysteresisOffOption1.Enabled = false;
            }
        }

        private void incrementOption_CheckedChanged(object sender, EventArgs e)
        {
            if (incrementOption.Checked == true)
                option = 96;
        }

        private void decrementOption_CheckedChanged(object sender, EventArgs e)
        {
            if (decrementOption.Checked == true)
                option = 0;
        }

        private void hysteresisOnOption_CheckedChanged(object sender, EventArgs e)
        {
            if (hysteresisOnOption.Checked == true)
                option = 96;
        }

        private void hysteresisOffOption_CheckedChanged(object sender, EventArgs e)
        {
            if (hysteresisOffOption.Checked == true)
                option = 0;
        }

        private void incrementOption1_CheckedChanged(object sender, EventArgs e)
        {
            if (incrementOption1.Checked == true)
                option1 = 96;
        }

        private void decrementOption1_CheckedChanged(object sender, EventArgs e)
        {
            if (decrementOption1.Checked == true)
                option1 = 0;
        }

        private void hysteresisOnOption1_CheckedChanged(object sender, EventArgs e)
        {
            if (hysteresisOnOption1.Checked == true)
                option1 = 96;
        }

        private void hysteresisOffOption1_CheckedChanged(object sender, EventArgs e)
        {
            if (hysteresisOffOption1.Checked == true)
                option1 = 0;
        }

        private void clearButton_Click(object sender, EventArgs e)
        {
            int ret = 0;

            // Clears the timer
            if ((ret = this.board.ClearCounterValue(moduleNbr)) != 0)
            {
                MessageBox.Show("Error " + ret.ToString() + " in ClearCounterValue");
                return;
            }
            // Starts to display the current value of the counter(s)
        }

        private void writeButton_Click(object sender, EventArgs e)
        {
            int ret = 0;

            if (counterRange == 0) // 1x 32-bit counter
            {
                // Write the value on the 32-bit counter
                if((ret = this.board.Write32BitCounterValue(moduleNbr, (uint)writeValue.Value)) != 0)
                {
                    MessageBox.Show("Error " + ret.ToString() + " in Write32BitCounterValue");
                    return;
                }
            }
            else if (counterRange == 16) // 2x 16-bit counter
            {
                // Write the value on the first 16-bit counter
                if ((ret = this.board.Write16BitCounterValue(moduleNbr, 0, (uint)writeValue.Value)) != 0)
                {
                    MessageBox.Show("Error " + ret.ToString() + " in Write16BitCounterValue");
                    return;
                }
            }
        }

        private void writeButton1_Click(object sender, EventArgs e)
        {
            int ret = 0;

            if (counterRange == 16)
            {
                // Write the value on the second 16-bit counter
                if ((ret = this.board.Write16BitCounterValue(moduleNbr, 1, (uint)writeValue1.Value)) != 0)
                {
                    MessageBox.Show("Error " + ret.ToString() + " in Write16BitCounterValue");
                    return;
                }
            }
        }

        private void initButton_Click(object sender, EventArgs e)
        {
            int ret = 0;
            
            // Initializes the counter(s)
            if ((ret = this.board.InitCounter(moduleNbr, counterRange, mode, option, mode1, option1)) != 0)
            {
                MessageBox.Show("Error " + ret.ToString() + " in InitCounter");
                return;
            }

            timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int ret = 0;
            uint readValue = 0;

            if (counterRange == 0) // 1x 32-bit counter
            {
                // Read the current value of the 32-bit counter
                if ((ret = this.board.Read32BitCounterValue(moduleNbr, out readValue)) != 0)
                {
                    MessageBox.Show("Error " + ret.ToString() + " in Read32BitCounterValue");
                    return;
                }
                counterCurrentValue.Text = readValue.ToString();
            }
            else if (counterRange == 16) // 2x 16-bit counters
            {
                // Read the current value of the first 16-bit counters
                if ((ret = this.board.Read16BitCounterValue(moduleNbr, 0, out readValue)) != 0)
                {
                    MessageBox.Show("Error " + ret.ToString() + " in Read16BitCounterValue");
                    return;
                }
                counterCurrentValue.Text = readValue.ToString();

                // Read the current value of the second 16-bit counters
                if ((ret = this.board.Read16BitCounterValue(moduleNbr, 1, out readValue)) != 0)
                {
                    MessageBox.Show("Error " + ret.ToString() + " in Read16BitCounterValue");
                    return;
                }
                counter1CurrentValue.Text = readValue.ToString();
            }
        }
    }
}
