function [returnValue, hour, minute, second, millisecond, microsecond, nanosecond] = i_PCI1710_mexConvertETMValue(deviceHandle, moduleNumber, ETMValue)
% i_PCI1710_mexConvertETMValue
%
% Converts the measured ETM time in hours, minutes, seconds, milliseconds, microseconds and nanoseconds.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    ETMValue                  "ETM time value. See i_PCI1710_ReadETMValue"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%    hour                      "Time measurement in hours"
%    minute                    "Time measurement in minutes"
%    second                    "Time measurement in seconds"
%    millisecond               "Time measurement in milliseconds"
%    microsecond               "Time measurement in microseconds"
%    nanosecond                "Time measurement in nanoseconds"
%
%Example:
% // Add an example here

[returnValue, hour, minute, second, millisecond, microsecond, nanosecond] = i_PCI1710_mexConvertETMValue(deviceHandle, moduleNumber, ETMValue);
