function [returnValue] = i_PCI1710_mexEnableDisablePWMDigitalOutputManualSetting(deviceHandle, modulNbr, flag)
% i_PCI1710_mexEnableDisablePWMDigitalOutputManualSetting
%
% Enables or disables to set manually the digital output H of the selected module.
% When the PWM 0 will be enabled for the first time, the digital output manual setting will be considered as disabled, which means that it would the PWM 0 which will control the digital output of the selected module.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    modulNbr                  "Number of the module to configure (0 to 3)"
%    flag                      "Enable/disable flag (0: disable the manual setting, the output H is controlled parallely to the PWM0, or 1: enable the manual setting, the output H will be set via the i_PCI1710_SetPWMDigitalOutputOn function or reset via the i_PCI1710_SetPWMDigitalOutputOff function)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%
%Example:
% // Add an example here

[returnValue] = i_PCI1710_mexEnableDisablePWMDigitalOutputManualSetting(deviceHandle, modulNbr, flag);
