function [returnValue] = i_PCI1710_mexEnableETM(deviceHandle, moduleNumber, ETM, edgeLevel, triggerLevel, cycleMode, firstTriggerMode, interruptEnable)
% i_PCI1710_mexEnableETM
%
% Enables the ETM counter of the selected module.
% The function i_PCI1710_InitETM has to be called first.
% If interrupts are enabled, the ETM counter generates an interrupt after each trigger signal.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    ETM                       "Selection of the ETM counter (0 or 1)"
%    edgeLevel                 "b_EdgeLevel Edge selection for time measurement (0: Measures the low level time, 1: Measures the high level time)"
%    triggerLevel              "Selection of the trigger level (0: Trigger at low level, 1: Trigger at high level)"
%    cycleMode                 "Mode selection (0: Single mode, 1: Continuous Mode). Each trigger stops the measurement and starts a new cycle."
%    firstTriggerMode          "Mode of the first trigger 0: The measurement of the first edge time starts after calling the function i_PCI1710_EnableETM. 1: The measurement of the first edge time starts after the next trigger signal."
%    interruptEnable           "Enables or disables the interrupt function. (0: interrupts disabled, 1: interrupts enabled)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%
%Example:
% // Add an example here

[returnValue] = i_PCI1710_mexEnableETM(deviceHandle, moduleNumber, ETM, edgeLevel, triggerLevel, cycleMode, firstTriggerMode, interruptEnable);
