function [returnValue] = i_PCI1710_mexEnablePWM(deviceHandle, moduleNumber, PWM, startLevel, stopMode, stopLevel, externGate, interruptEnable)
% i_PCI1710_mexEnablePWM
%
% Enables the selected PWM of the selected module.
% The i_PCI1710_InitPWM function must be called before calling this function.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    PWM                       "Index of the selected PWM (0 or 1)"
%    startLevel                "Start period level selection (0: the period will start with a low level, 1: the period will start with a high level)"
%    stopMode                  "Stop mode selection (0: the PWM will be stopped directly after the call of the i_PCI1710_DisablePWM function, 1: the PWM will be stopped after the end of the last period after the call of the disable function)"
%    stopLevel                 "Stop PWM level selection (0: the output signal will keep its level after the call of the i_PCI1710_DisablePWM function, 1: the output signal will be set to low after the call of the disable function, 2: the output signal will be set to high after the call of the disable function)"
%    externGate                "Extern gate action selection (0: extern gate signal not used, 1: extern gate signal used)"
%    interruptEnable           "Enable or disable the interrupt (0: disable the PWM interrupt, 1: an interrupt will occur after each end of state)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%
%Example:
% // Add an example here

[returnValue] = i_PCI1710_mexEnablePWM(deviceHandle, moduleNumber, PWM, startLevel, stopMode, stopLevel, externGate, interruptEnable);
