//##protect##"FileHeader"
/** @file i_PCI1710_mexGetBoardHardwareType.c
 *
 *  @authors S. Beuque, C. Guinot, J. Krauth, N. Reibel, J. Rose, L. Sartory, S. Weber
 *  @date    Creation: 25.10.2012
 *  @date    $LastChangedDate$
 *  @version $LastChangedRevision$
 *
 *  @par DESCRIPTION
 *  i_PCI1710_mexGetBoardHardwareType MEX file 
 *
 *  @par LICENCE
 *  @verbatim
 *  Copyright (C) 2009 - 2012 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmnster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 *  @endverbatim
 **/
//##protect##"FileHeader"

#include "..\..\C\Include\PCI1710.h"
#include "mex.h"
#include "matrix.h"

/* i_PCI1710_mexGetBoardHardwareType */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	/* Declaration of the local variables of the function */
	INT *returnValue = mxCalloc(1, sizeof(INT));
	HANDLE deviceHandle = 0;
	BYTE *hardwareType = mxCalloc(1, sizeof(BYTE));
//##protect##"i_PCI1710_mexGetBoardHardwareType_VariablesDefinition"
//##protect##"i_PCI1710_mexGetBoardHardwareType_VariablesDefinition"

	/* Check the number of input and output parameters */
	if (nrhs != 1)
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_mexGetBoardHardwareType:nrhs", "1 input is required.\n");
	if (nlhs != 2)
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_mexGetBoardHardwareType:nlhs", "2 outputs are required.\n");

	/* Acquisition of the input(s) */
	deviceHandle = (HANDLE)(INT_PTR)mxGetScalar(prhs[0]);

	/* Check of the values of the input parameters */

//##protect##"i_PCI1710_mexGetBoardHardwareType_Start"
//##protect##"i_PCI1710_mexGetBoardHardwareType_Start"

	/* Call of the C function */
	*returnValue = i_PCI1710_GetBoardHardwareType(deviceHandle, hardwareType);

	/* Creation of the output(s) */
	plhs[0] = mxCreateNumericArray(0, NULL, mxINT16_CLASS, mxREAL);
	mxSetData(plhs[0], returnValue);  mxSetM(plhs[0], 1);  mxSetN(plhs[0], 1);
	plhs[1] = mxCreateNumericArray(0, NULL, mxUINT8_CLASS, mxREAL);
	mxSetData(plhs[1], hardwareType);  mxSetM(plhs[1], 1);  mxSetN(plhs[1], 1);

//##protect##"i_PCI1710_mexGetBoardHardwareType_End"
//##protect##"i_PCI1710_mexGetBoardHardwareType_End"
}
