//##protect##"FileHeader"
/** @file 
 *
 *  @authors S. Beuque, C. Guinot, J. Krauth, N. Reibel, J. Rose, L. Sartory, S. Weber
 *  @date    Creation: 31.01.2013
 *  @date    $LastChangedDate$
 *  @version $LastChangedRevision$
 *
 *
 *  @par LICENCE
 *  @verbatim
 *  Copyright (C) 2009 - 2013 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmnster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 *  @endverbatim
 **/
//##protect##"FileHeader"

#include "..\..\C\Include\PCI1710.h"
#include "mex.h"
#include "matrix.h"

/* i_PCI1710_mexGetDLLVersion */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	/* Declaration of the arguments of the function */
	INT *returnValue = mxCalloc(1, sizeof(INT));
	DWORD DLLVersion = 0;

	UNREFERENCED_PARAMETER(prhs);

	/* Check the number of input and output parameters */
	if (nrhs != 0)
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_GetDLLVersion:nrhs", "No input required.\n");
	if (nlhs != 2)
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_GetDLLVersion:nlhs", "2 outputs are required.\n");

	/* Call of the C function */
	*returnValue = i_PCI1710_GetDLLVersion(&DLLVersion);

	/* Creation of the output(s) */
	plhs[0] = mxCreateNumericArray(0, NULL, mxINT16_CLASS, mxREAL);
	mxSetData(plhs[0], returnValue);  mxSetM(plhs[0], 1);  mxSetN(plhs[0], 1);
	plhs[1] = mxCreateDoubleScalar((double)DLLVersion);
}
