function [returnValue, timingUnit, timing, edgeLevel, triggerLevel, cycleMode, firstTriggerMode, interruptEnable, enable] = i_PCI1710_mexGetETMInitialisation(deviceHandle, moduleNumber, ETM)
% i_PCI1710_mexGetETMInitialisation
%
% Returns the information about the ETM initialisation for the selected module
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    ETM                       "Selection of the ETM counter (0 or 1)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%    timingUnit                "Unit of the time base (0: ns 1: us 2: ms)"
%    timing                    "Value of the time base"
%    edgeLevel                 "b_EdgeLevel Edge selection for time measurement (0: Measures the low level time, 1: Measures the high level time)"
%    triggerLevel              "Selection of the trigger level (0: Trigger at low level, 1: Trigger at high level)"
%    cycleMode                 "Mode selection (0: Single mode, 1: Continuous Mode). Each trigger stops the measurement and starts a new cycle."
%    firstTriggerMode          "Mode of the first trigger 0: The measurement of the first edge time starts after calling the function i_PCI1710_EnableETM. 1: The measurement of the first edge time starts after the next trigger signal."
%    interruptEnable           "Enables or disables the interrupt function. (0: interrupts disabled, 1: interrupts enabled)"
%    enable                    "Returns whether the ETM is enabled or disabled. (0: ETM disabled, 1: ETM enabled)"
%
%Example:
% // Add an example here

[returnValue, timingUnit, timing, edgeLevel, triggerLevel, cycleMode, firstTriggerMode, interruptEnable, enable] = i_PCI1710_mexGetETMInitialisation(deviceHandle, moduleNumber, ETM);
