function [returnValue, PWMOutputStatus, externGateStatus] = i_PCI1710_mexGetPWMStatus(deviceHandle, modulNbr, PWM)
% i_PCI1710_mexGetPWMStatus
%
% Returns the selected PWM status of the selected module.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    modulNbr                  "Number of the module to configure (0 to 3)"
%    PWM                       "Selected PWM (0 or 1)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%    PWMOutputStatus           "Returns the PWM output level status (0: low or 1: high)"
%    externGateStatus          "Returns the extern gate level status (0: low or 1: high)"
%
%Example:
% // Add an example here

[returnValue, PWMOutputStatus, externGateStatus] = i_PCI1710_mexGetPWMStatus(deviceHandle, modulNbr, PWM);
