function [returnValue] = i_PCI1710_mexInitCounter(deviceHandle, moduleNumber, counterRange, firstCounterModus, firstCounterOption, secondCounterModus, secondCounterOption)
% i_PCI1710_mexInitCounter
%
% Configures the counter operation mode of the selected module
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    counterRange              "Selection of the counter range (0: 32-bit counter, 1: 163-bit counter)"
%    firstCounterModus         "Operation mode of the first counter (0: quadruple mode, 3: double mode, 15: simple mode, 128: direct mode)"
%    firstCounterOption        "Option of the first counter (if first counter mode is direct mode, 0: decrement, 96: increment; if first counter mode is quadruple, double or single, 0: hysteresis off, 96:hysteresis on)"
%    secondCounterModus        "Operation mode of the second counter (0: quadruple mode, 3: double mode, 15: simple mode, 128: direct mode)"
%    secondCounterOption       "Option of the second counter (if first counter mode is direct mode, 0: decrement, 96: increment; if first counter mode is quadruple, double or single, 0: hysteresis off, 96:hysteresis on)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%
%Example:
% // Add an example here

[returnValue] = i_PCI1710_mexInitCounter(deviceHandle, moduleNumber, counterRange, firstCounterModus, firstCounterOption, secondCounterModus, secondCounterOption);
