function [returnValue, realTiming] = i_PCI1710_mexInitETM(deviceHandle, moduleNumber, clockSelection, timingUnit, timing)
% i_PCI1710_mexInitETM
%
% Configures all ETM counters of the selected module.
% The parameters dw_Timing und dw_TimingUnit determine the time base for the measurement.
% pdw_RealTiming returns the correct time value.
% Call this function before you call another function that accesses the ETM counter.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    clockSelection            "Selection of the reference clock (30: PCI clock (30 MHz), 33: PCI clock (33 MHz), 40: 40 MHz onboard quartz)"
%    timingUnit                "Unit of the time base (0: ns 1: us 2: ms)"
%    timing                    "Value of the time base"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%    realTiming                "Correct value of the time base. Returns the value that corresponds best with the value entered in dw_Timing"
%
%Example:
% // Add an example here

[returnValue, realTiming] = i_PCI1710_mexInitETM(deviceHandle, moduleNumber, clockSelection, timingUnit, timing);
