function [returnValue] = i_PCI1710_mexInitIndex(deviceHandle, moduleNumber, referenceAction, indexOperation, autoMode, interruptEnable)
% i_PCI1710_mexInitIndex
%
% Initializes the index that corresponds with the selected module.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    referenceAction           "Determines if the reference for the index-transfer shall be reset or not (0: reference has not an importance, 1: reference shall be set for the index transfer)"
%    indexOperation            "Index operation mode (0: after an index signal (high level) the counter value (32-bit) is latched into the first latch register, 1: after an index signal (low level), the counter value (32-bit) is latched into the first latch register, 2: after an index signal (high level), the counter value is deleted (32-bit), 3: after an index signal (low level), the counter value is deleted (32-bit), 4: after an index signal (high level), the counter value (32-bit) is latched into the first latch register and then deleted (32-bit), 5: after an index signal (low level), the counter value (32-bit) is latched into the first latch register and then deleted (32-bit))"
%    autoMode                  "Enables or disables the automatic index reset (0: disables, 1: enables)"
%    interruptEnable           "Enables or disables the interrupt (0: disables, 1: enables)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%
%Example:
% // Add an example here

[returnValue] = i_PCI1710_mexInitIndex(deviceHandle, moduleNumber, referenceAction, indexOperation, autoMode, interruptEnable);
