function [returnValue, realLowTiming, realHighTiming] = i_PCI1710_mexInitPWM(deviceHandle, moduleNumber, PWM, timingUnit, lowTiming, highTiming)
% i_PCI1710_mexInitPWM
%
% This function configures the selected PWM from the selected module.
% The dw_LowTiming, dw_HighTiming and b_TimingUnit determine the low/high base timing for the period.
% The pdw_RealLowTiming and pdw_RealHighTiming return the real timing value.
% You must call this function before calling any other PWM function.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    PWM                       "Index of the selected PWM (0 or 1)"
%    timingUnit                "Timing unit (0: ns, 1: us, 2: ms, 3: sec or 4: min)"
%    lowTiming                 "Low base timing value"
%    highTiming                "High base timing value"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%    realLowTiming             "Real low base timing value"
%    realHighTiming            "Real high base timing value"
%
%Example:
% // Add an example here

[returnValue, realLowTiming, realHighTiming] = i_PCI1710_mexInitPWM(deviceHandle, moduleNumber, PWM, timingUnit, lowTiming, highTiming);
