function [returnValue] = i_PCI1710_mexInitSSI(deviceHandle, moduleNumber, profileLength, positionLength, turnCptLength, PCIInputClock, outputClock, countingMode)
% i_PCI1710_mexInitSSI
%
% Initialises the SSI on a given module.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    profileLength             "Length of the profile (in bits). The profile is the position length plus the turn counter length in bits (from 2 to 32)"
%    positionLength            "Length of the position (in bits). This value represents the current position in the current turn"
%    turnCptLength             "Length of the turn counter in bits (b_PositionLength + b_TurnCptLength must not be bigger than b_ProfileLength). This arugment can be put to 0. In this case, the counter is in single turn mode, and b_positionLength must be equal to b_ProfileLength"
%    PCIInputClock             "Frequency of the input clock (30: 30 MHz, 33: 33 MHz). See your PC's PCI clock in its manual"
%    outputClock               "Output clock (from 229 to 5 000 000 Hz for a 30 MHz PCI input clock, and from 252 to 5 000 000 Hz for a 30 MHz PCI input clock)"
%    countingMode              "Selectin of the counting mode (0: binary: a conversion is made, 1: Gray code: no conversion is made)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%
%Example:
% // Add an example here

[returnValue] = i_PCI1710_mexInitSSI(deviceHandle, moduleNumber, profileLength, positionLength, turnCptLength, PCIInputClock, outputClock, countingMode);
