function [returnValue] = i_PCI1710_mexInitSSIRawData(deviceHandle, moduleNumber, profileLength, PCIInputClock, outputClock)
% i_PCI1710_mexInitSSIRawData
%
% Initialises the SSI on a given module.
% The difference with the other initialization lies in the fact that datas are not formated.
% So the read values will have their parity bit, turn count and position will not be automatically separated and so on.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    profileLength             "Length of the profile (in bits). The profile is the position length plus the turn counter length in bits (from 2 to 32)"
%    PCIInputClock             "Frequency of the input clock (30: 30 MHz, 33: 33 MHz). See your PC's PCI clock in its manual"
%    outputClock               "Output clock (from 229 to 5 000 000 Hz for a 30 MHz PCI input clock, and from 252 to 5 000 000 Hz for a 30 MHz PCI input clock)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%
%Example:
% // Add an example here

[returnValue] = i_PCI1710_mexInitSSIRawData(deviceHandle, moduleNumber, profileLength, PCIInputClock, outputClock);
