//##protect##"FileHeader"
/** @file i_PCI1710_mexInitTTLIODirection.c
 *
 *  @authors S. Beuque, C. Guinot, J. Krauth, N. Reibel, J. Rose, L. Sartory, S. Weber
 *  @date    Creation: 25.10.2012
 *  @date    $LastChangedDate$
 *  @version $LastChangedRevision$
 *
 *  @par DESCRIPTION
 *  i_PCI1710_mexInitTTLIODirection MEX file 
 *
 *  @par LICENCE
 *  @verbatim
 *  Copyright (C) 2009 - 2012 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmnster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 *  @endverbatim
 **/
//##protect##"FileHeader"

#include "..\..\C\Include\PCI1710.h"
#include "mex.h"
#include "matrix.h"

/* i_PCI1710_mexInitTTLIODirection */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	/* Declaration of the local variables of the function */
	INT *returnValue = mxCalloc(1, sizeof(INT));
	HANDLE deviceHandle = 0;
	BYTE moduleNumber = 0;
	BYTE portAMode = 0;
	BYTE portBMode = 0;
	BYTE portCMode = 0;
	BYTE portDMode = 0;
//##protect##"i_PCI1710_mexInitTTLIODirection_VariablesDefinition"
//##protect##"i_PCI1710_mexInitTTLIODirection_VariablesDefinition"

	/* Check the number of input and output parameters */
	if (nrhs != 6)
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_mexInitTTLIODirection:nrhs", "6 inputs are required.\n");
	if (nlhs != 1)
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_mexInitTTLIODirection:nlhs", "1 output is required.\n");

	/* Acquisition of the input(s) */
	deviceHandle = (HANDLE)(INT_PTR)mxGetScalar(prhs[0]);
	moduleNumber = (BYTE)mxGetScalar(prhs[1]);
	portAMode = (BYTE)mxGetScalar(prhs[2]);
	portBMode = (BYTE)mxGetScalar(prhs[3]);
	portCMode = (BYTE)mxGetScalar(prhs[4]);
	portDMode = (BYTE)mxGetScalar(prhs[5]);

	/* Check of the values of the input parameters */
	if ((moduleNumber < 0) || (moduleNumber > 3))
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_mexInitTTLIODirection:nlhs", "The moduleNumber input must be between 0 and 3.\n");
	if ((portAMode < 0) || (portAMode > 1))
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_mexInitTTLIODirection:nlhs", "The portAMode input must be between 0 and 1.\n");
	if ((portBMode < 0) || (portBMode > 1))
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_mexInitTTLIODirection:nlhs", "The portBMode input must be between 0 and 1.\n");
	if ((portCMode < 0) || (portCMode > 1))
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_mexInitTTLIODirection:nlhs", "The portCMode input must be between 0 and 1.\n");
	if ((portDMode < 0) || (portDMode > 1))
		mexErrMsgIdAndTxt("MyToolbox:i_PCI1710_mexInitTTLIODirection:nlhs", "The portDMode input must be between 0 and 1.\n");

//##protect##"i_PCI1710_mexInitTTLIODirection_Start"
//##protect##"i_PCI1710_mexInitTTLIODirection_Start"

	/* Call of the C function */
	*returnValue = i_PCI1710_InitTTLIODirection(deviceHandle, moduleNumber, portAMode, portBMode, portCMode, portDMode);

	/* Creation of the output(s) */
	plhs[0] = mxCreateNumericArray(0, NULL, mxINT16_CLASS, mxREAL);
	mxSetData(plhs[0], returnValue);  mxSetM(plhs[0], 1);  mxSetN(plhs[0], 1);

//##protect##"i_PCI1710_mexInitTTLIODirection_End"
//##protect##"i_PCI1710_mexInitTTLIODirection_End"
}
