function [returnValue] = i_PCI1710_mexInitTimer(deviceHandle, moduleNumber, timerNumber, timerMode, reloadValue, inputClockSelection, inputClockLevel, outputLevel, hardwareGateLevel)
% i_PCI1710_mexInitTimer
%
% Initializes a 82c54 timer.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    timerNumber               "Number of the timer (from 0 to 2)"
%    timerMode                 "Mode in which the timer has to be initialized (from 0 to 5)"
%    reloadValue               "Reload value of the timer (from 0 to 4 294 967 295)"
%    inputClockSelection       "Selection of the clock to use (1: external clock, 2: internal 10 MHz clock). For the timer 0, only the internal 10 MHz clock is available"
%    inputClockLevel           "Level of the clock (0: active at low, 1: active a high (input inverted))"
%    outputLevel               "Selection of the output clock level (0: active at low (inverted), 1: active a high)"
%    hardwareGateLevel         "Selection of the hardware gate level (0: active at low (inverted), 1: active a high). If the external gate is not used, this parameter must be set to 0"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%
%Example:
% // Add an example here

[returnValue] = i_PCI1710_mexInitTimer(deviceHandle, moduleNumber, timerNumber, timerMode, reloadValue, inputClockSelection, inputClockLevel, outputLevel, hardwareGateLevel);
