function [returnValue, ETMStatus, dutyCycle] = i_PCI1710_mexReadETMDutyCycleValue(deviceHandle, moduleNumber, ETM, timeOut)
% i_PCI1710_mexReadETMDutyCycleValue
%
% Returns the ETM status and the duty cycle value after a stop signal occurred on the selected ETM module.
% This function is only available if you have disabled the interrupt function.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    ETM                       "Selection of the ETM counter (0 or 1)"
%    timeOut                   "Selection of the timeout in ms. (0 to 65535, 0: Blocking until a stop signal has arrived)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%    ETMStatus                 "The ETM state. (0: No start trigger arrived, 1: A start trigger has arrived, 2: A stop trigger has arrived, 3: Transition has been realised, 4: Timeout reached)"
%    dutyCycle                 "ETM duty cycle."
%
%Example:
% // Add an example here

[returnValue, ETMStatus, dutyCycle] = i_PCI1710_mexReadETMDutyCycleValue(deviceHandle, moduleNumber, ETM, timeOut);
