function [returnValue, ETMStatus, ETMValue] = i_PCI1710_mexReadETMValue(deviceHandle, moduleNumber, ETM, timeOut)
% i_PCI1710_mexReadETMValue
%
% Returns the ETM state and the time value after a stop signal on the selected module.
% This function is only available when you disable the interrupt function.
% The returned value is not the actual measured time value. You must use the function i_PCI1710_ConvertETMValue or apply the following formula in order to calculate the time value:
% Time value = pdw_ETMValue x pdw_RealTiming
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    ETM                       "Selection of the ETM counter (0 or 1)"
%    timeOut                   "Selection of the timeout in ms. (0 to 65535, 0: Blocking until a stop signal has arrived)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%    ETMStatus                 "The ETM state. (0: No start trigger arrived, 1: A start trigger has arrived, 2: A stop trigger has arrived, 3: Transition has been realised, 4: Timeout reached)"
%    ETMValue                  "ETM time value."
%
%Example:
% // Add an example here

[returnValue, ETMStatus, ETMValue] = i_PCI1710_mexReadETMValue(deviceHandle, moduleNumber, ETM, timeOut);
