function [returnValue, latchStatus] = i_PCI1710_mexReadLatchRegisterStatus(deviceHandle, moduleNumber, latchReg)
% i_PCI1710_mexReadLatchRegisterStatus
%
% Reads the status of the selected latch register of the selected module.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    latchReg                  "Selection of the latch register (0: for the first latch register, 1: for the second latch register)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%    latchStatus               "Latch register status (0: no latch, 1: a software latch was generated, 2: a hardware latch was generated, 3: a software latch and a hardware latch were generated)"
%
%Example:
% // Add an example here

[returnValue, latchStatus] = i_PCI1710_mexReadLatchRegisterStatus(deviceHandle, moduleNumber, latchReg);
