function [returnValue] = i_PCI1710_mexSetInputFilter(deviceHandle, moduleNumber, PCIInputClock, filter)
% i_PCI1710_mexSetInputFilter
%
% Disables or enables the software filter in the selected module for the inputs A, B, C and D.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    PCIInputClock             "Selection of the bus clock (30: 30 MHz, 33: 33 MHz, 40: 40 MHz)"
%    filter                    "Selection of the filter for the inputs A, B, C and D (0: filter not used, 1: 100 ns, 2: 150 ns, 3: 200 ns, 4: 250 ns, 5: 300 ns, 6: 350 ns, 7: 400 ns, 8: 450 ns, 9: 500 ns, 10: 550 ns, 11: 600 ns, 12: 650 ns, 13: 700 ns, 14: 750 ns, 15: 800 ns)"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%
%Example:
% // Add an example here

[returnValue] = i_PCI1710_mexSetInputFilter(deviceHandle, moduleNumber, PCIInputClock, filter);
