function [returnValue] = i_PCI1710_mexSetNewPWMTiming(deviceHandle, moduleNumber, PWM, timingUnit, lowTiming, highTiming)
% i_PCI1710_mexSetNewPWMTiming
%
% Sets a new timing.
% The dw_LowTiming, dw_HighTiming and b_TimingUnit determine the low/high base timing for the period.
%
% Input parameters:
%    deviceHandle              "Handle of the board"
%    moduleNumber              "Number of the module to be configured (from 0 to 3)"
%    PWM                       "Index of the selected PWM (0 or 1)"
%    timingUnit                "Timing unit (0: ns, 1: us, 2: ms, 3: sec or 4: min)"
%    lowTiming                 "Low base timing value"
%    highTiming                "High base timing value"
%
% Output parameters:
%    returnValue               "Value returned by the function"
%
%Example:
% // Add an example here

[returnValue] = i_PCI1710_mexSetNewPWMTiming(deviceHandle, moduleNumber, PWM, timingUnit, lowTiming, highTiming);
